package com.chinaitop;

import org.mybatis.spring.annotation.MapperScan;
import org.springframework.boot.SpringApplication;
import org.springframework.boot.autoconfigure.SpringBootApplication;
import org.springframework.cloud.client.discovery.EnableDiscoveryClient;
import org.springframework.cloud.netflix.eureka.EnableEurekaClient;
import org.springframework.cloud.openfeign.EnableFeignClients;

import com.github.pagehelper.autoconfigure.PageHelperAutoConfiguration;

//import springfox.documentation.swagger2.annotations.EnableSwagger2;

//@EnableSwagger2 //表示开启swagger
@EnableEurekaClient
@EnableDiscoveryClient
@EnableFeignClients
@SpringBootApplication(exclude = PageHelperAutoConfiguration.class)//配置mybatis的配置文件使用，否则报多个分页插件
@MapperScan(basePackages = {"com.chinaitop.depot.*.mapper"})
public class DepotBasicApplication {

	public static void main(String[] args) {
		System.setProperty("druid.testWhileIdle", "true");
		System.setProperty("druid.validationQuery", "SELECT 1 FROM DUAL");
		SpringApplication.run(DepotBasicApplication.class, args);
	}
}
