package com.chinaitop.depot.DataDocking.controller;

import java.util.HashMap;
import java.util.Map;

import javax.annotation.Resource;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.http.MediaType;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestMethod;
import org.springframework.web.bind.annotation.RestController;

import com.chinaitop.depot.basic.service.BasicStorehouseService;
import com.chinaitop.depot.basic.service.BasicTankService;
import com.chinaitop.depot.basic.service.SystemOutsideDataService;

import io.swagger.annotations.Api;
import io.swagger.annotations.ApiImplicitParam;
import io.swagger.annotations.ApiImplicitParams;
import io.swagger.annotations.ApiOperation;

@RestController
@RequestMapping(value = "/DataController")
@Api(value= "DataController", description = "基础数据对接控制类")
public class DataController {
	
	final static Logger logger = LoggerFactory.getLogger(DataController.class);

    @Resource
    private BasicTankService basicTankService;
    
    @Resource
    private BasicStorehouseService basicStorehouseService;
    
    @Resource
	private SystemOutsideDataService systemOutsideDataService;

    @RequestMapping(value = "/tankEdit", produces = MediaType.APPLICATION_JSON_VALUE, method = RequestMethod.POST)
    @ApiOperation(value="接收市平台传过来的油罐基础数据")
    @ApiImplicitParams({
            @ApiImplicitParam(name = "datas", value = "数据串", paramType = "form")
    })
    public Map<String, String> tankEdit(String datas) {
    	Map<String, String> resultMap = new HashMap<>();
    	logger.info("接收到市平台传来的油罐数据串是：\r\n"+datas);

    	try {
			resultMap = basicTankService.saveOrUpdateSptTankData(datas);
			systemOutsideDataService.addlogger("ygjcsj", datas, resultMap.toString());
		} catch (Exception e) {
			resultMap.put("status", "error");
			resultMap.put("msg", "数据存储异常，请联系管理员");
			logger.error(e.getMessage(), e);
			systemOutsideDataService.addlogger("ygjcsj", datas, resultMap.toString());
		}
    	logger.info("接收到市平台传来的油罐数据串返回结果时是：\r\n"+resultMap);
		return resultMap;
    }

    @RequestMapping(value = "/storehouseEdit", produces = MediaType.APPLICATION_JSON_VALUE, method = RequestMethod.POST)
    @ApiOperation(value="接收市平台传过来的仓房基础数据")
    @ApiImplicitParams({
            @ApiImplicitParam(name = "datas", value = "数据串", paramType = "form")
    })
    public Map<String, String> storehouseEdit(String datas) {
    	Map<String, String> resultMap = new HashMap<>();
    	logger.info("接收到市平台传来的仓房数据串是：\r\n"+datas);

    	try {
			resultMap = basicStorehouseService.saveOrUpdateSptStorehouseData(datas);
			systemOutsideDataService.addlogger("cfjcsj", datas, resultMap.toString());
		} catch (Exception e) {
			resultMap.put("status", "error");
			resultMap.put("msg", "数据存储异常，请联系管理员");
			logger.error(e.getMessage(), e);
			systemOutsideDataService.addlogger("cfjcsj", datas, resultMap.toString());
		}
    	logger.info("接收到市平台传来的仓房数据串返回结果时是：\r\n"+resultMap);
		return resultMap;
    }

}
