package com.chinaitop.depot.basic.controller;

import javax.annotation.Resource;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import io.swagger.annotations.ApiImplicitParam;
import io.swagger.annotations.ApiImplicitParams;
import org.springframework.http.MediaType;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestMethod;
import org.springframework.web.bind.annotation.RestController;

import com.chinaitop.depot.basic.service.UserAndCfHwExportService;

import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;

@RestController
@RequestMapping(value="/basicExportAndImport")
@Api(value= "UserAndCFHWExportController", description = "导出用户和仓房信息控制类")
public class UserAndCFHWExportController {

	@Resource
	private UserAndCfHwExportService service;

	/**
	 * 导出当前单位的用户信息和仓房货位信息
	 * 
	 * @param request
	 * @param response
	 */
	@RequestMapping(value="/exportUserAndCfHw", produces = MediaType.APPLICATION_JSON_VALUE, method = RequestMethod.POST)
	@ApiOperation(value="导出当前单位的用户信息和仓房货位信息", notes = "导出当前单位的用户信息和仓房货位信息")
	@ApiImplicitParams({
			@ApiImplicitParam(name = "userDateList", value = "用户信息", paramType = "query")
	})
	public void exportUserAndCfhw(HttpServletRequest request, HttpServletResponse response, String userDateList) {
		service.exportUserAndCfhw(request, response, userDateList);
	}
}
