package com.chinaitop.depot.basic.mapper;

import com.chinaitop.depot.basic.model.BasicWarehouse;
import com.chinaitop.depot.basic.model.BasicWarehouseExample;
import com.chinaitop.depot.basic.model.BasicWarehouseVO;

import java.util.List;
import java.util.Map;

import org.apache.ibatis.annotations.Param;

public interface BasicWarehouseMapper {
    int countByExample(BasicWarehouseExample example);

    int deleteByExample(BasicWarehouseExample example);

    int deleteByPrimaryKey(Integer warehouseId);

    int insert(BasicWarehouse record);

    int insertSelective(BasicWarehouse record);

    List<BasicWarehouse> selectByExample(BasicWarehouseExample example);

    BasicWarehouse selectByPrimaryKey(Integer warehouseId);

    int updateByExampleSelective(@Param("record") BasicWarehouse record, @Param("example") BasicWarehouseExample example);

    int updateByExample(@Param("record") BasicWarehouse record, @Param("example") BasicWarehouseExample example);

    int updateByPrimaryKeySelective(BasicWarehouse record);

    int updateByPrimaryKey(BasicWarehouse record);

    BasicWarehouseVO getWareDataByHwbm(String hwbm);

    /**
     * 更新货位的出入库状态
     * @param param
     */
	void updateWareStatus(Map<String, Object> param);

	/**
	 * 查询一个粮食货位是不是封仓状态
	 * @param param
	 * @return
	 */
	List<Map<String, Object>> queryFenCangCfData(Map<String, Object> param);

    /**
     * 查询一个油罐货位是不是封仓状态
     * @param param
     * @return
     */
    List<Map<String, Object>> queryFenCangYgData(Map<String, Object> param);

	/**
	 * 修改原粮粮情卡归档状态
	 */
	int updateYlLqkGd(Map<String, Object> param);

    /**
     * 归档成品粮粮情卡状态
     */
    void updateCplLqkGd(Map<String, Object> param);

    /**
     * 归档自检数据
     * @param param 条件参数
     */
    void updateQualitycheck(Map<String, Object> param);

    /**
	 * 查询空的货位和油罐
	 * @param param
	 * @return
	 */
	List<Map<String, Object>> selectWareAndTank(Map<String, Object> param);
}