package com.chinaitop.depot.basic.model;

import java.util.Date;

import com.fasterxml.jackson.annotation.JsonFormat;

public class BasicKeeper {
    private Integer id;

    private Integer userId;

    private Integer postType;

    private String name;

    private String userAlias;

    private Integer deptId;

    private Integer orgId;

    private Integer sex;

    private String idCard;

    private String phone;

    private Date birthday;

    private String email;

    private Integer workYear;

    @JsonFormat(shape = JsonFormat.Shape.STRING, pattern = "yyyy-MM-dd", timezone = "GMT+8")
    private Date entryTime;

    //人员类别
    private Integer employeeNature;

    private Date handoverDate;

    private Integer inputPersonId;

    private Date inputDate;

    private Integer editPersonId;

    private Date editDate;

    private String houseId;

    private Integer provinceId;

    private Integer cityId;

    private Integer grainId;

    private String depotName;

    private String avatorUrl;

    private Integer nation;

    private Date isdepartmentTime;

    private Integer political;

    private String syncFlag;

    private Integer delFlag;
    //是否设计交流轮岗
    private String sfsjjllg;
    //名族
    private Integer mz;
    //职务
    private String zw;
    //在岗状态
    private String zgzt;
    //岗位性质
    private String gwxz;
    //参加涉粮企业工作时间
    private Date cjslqygzsj;
    //参加工作时间
    private Date cjgzsj;
    //关键部门负责人
    private String cyfzr;
    //岗位类型
    private String gwlb;

    //业务字段
    private String keeperNames;

    /**
     * 责任人员档案编号
     * @return id 责任人员档案编号
     */
    public Integer getId() {
        return id;
    }

    /**
     * 责任人员档案编号
     * @param id 责任人员档案编号
     */
    public void setId(Integer id) {
        this.id = id;
    }

    /**
     * 所属用户ID
     * @return user_Id 所属用户ID
     */
    public Integer getUserId() {
        return userId;
    }

    /**
     * 所属用户ID
     * @param userId 所属用户ID
     */
    public void setUserId(Integer userId) {
        this.userId = userId;
    }

    /**
     * 角色类型
     * @return post_type 角色类型
     */
    public Integer getPostType() {
        return postType;
    }

    /**
     * 角色类型
     * @param postType 角色类型
     */
    public void setPostType(Integer postType) {
        this.postType = postType;
    }

    /**
     * 职员姓名
     * @return name 职员姓名
     */
    public String getName() {
        return name;
    }

    /**
     * 职员姓名
     * @param name 职员姓名
     */
    public void setName(String name) {
        this.name = name == null ? null : name.trim();
    }

    /**
     * 用户别名
     * @return user_alias 用户别名
     */
    public String getUserAlias() {
        return userAlias;
    }

    /**
     * 用户别名
     * @param userAlias 用户别名
     */
    public void setUserAlias(String userAlias) {
        this.userAlias = userAlias == null ? null : userAlias.trim();
    }

    /**
     * 所属部门
     * @return dept_id 所属部门
     */
    public Integer getDeptId() {
        return deptId;
    }

    /**
     * 所属部门
     * @param deptId 所属部门
     */
    public void setDeptId(Integer deptId) {
        this.deptId = deptId;
    }

    /**
     * 组织编号
     * @return org_id 组织编号
     */
    public Integer getOrgId() {
        return orgId;
    }

    /**
     * 组织编号
     * @param orgId 组织编号
     */
    public void setOrgId(Integer orgId) {
        this.orgId = orgId;
    }

    /**
     * 性别(1.男，0.女)
     * @return sex 性别(1.男，0.女)
     */
    public Integer getSex() {
        return sex;
    }

    /**
     * 性别(1.男，0.女)
     * @param sex 性别(1.男，0.女)
     */
    public void setSex(Integer sex) {
        this.sex = sex;
    }

    /**
     * 身份证号
     * @return id_card 身份证号
     */
    public String getIdCard() {
        return idCard;
    }

    /**
     * 身份证号
     * @param idCard 身份证号
     */
    public void setIdCard(String idCard) {
        this.idCard = idCard == null ? null : idCard.trim();
    }

    /**
     * 联系电话
     * @return phone 联系电话
     */
    public String getPhone() {
        return phone;
    }

    /**
     * 联系电话
     * @param phone 联系电话
     */
    public void setPhone(String phone) {
        this.phone = phone == null ? null : phone.trim();
    }

    /**
     * 出生年月
     * @return birthday 出生年月
     */
    public Date getBirthday() {
        return birthday;
    }

    /**
     * 出生年月
     * @param birthday 出生年月
     */
    public void setBirthday(Date birthday) {
        this.birthday = birthday;
    }

    /**
     * 邮箱
     * @return email 邮箱
     */
    public String getEmail() {
        return email;
    }

    /**
     * 邮箱
     * @param email 邮箱
     */
    public void setEmail(String email) {
        this.email = email == null ? null : email.trim();
    }

    /**
     * 相关工作年限
     * @return work_Year 相关工作年限
     */
    public Integer getWorkYear() {
        return workYear;
    }

    /**
     * 相关工作年限
     * @param workYear 相关工作年限
     */
    public void setWorkYear(Integer workYear) {
        this.workYear = workYear;
    }

    /**
     * 入职时间
     * @return entry_time 入职时间
     */
    public Date getEntryTime() {
        return entryTime;
    }

    /**
     * 入职时间
     * @param entryTime 入职时间
     */
    public void setEntryTime(Date entryTime) {
        this.entryTime = entryTime;
    }

    /**
     * 人员类别
     * @return employee_nature 人员类别
     */
    public Integer getEmployeeNature() {
        return employeeNature;
    }

    /**
     * 人员类别
     * @param employeeNature 人员类别
     */
    public void setEmployeeNature(Integer employeeNature) {
        this.employeeNature = employeeNature;
    }

    /**
     * 交接日期
     * @return handover_Date 交接日期
     */
    public Date getHandoverDate() {
        return handoverDate;
    }

    /**
     * 交接日期
     * @param handoverDate 交接日期
     */
    public void setHandoverDate(Date handoverDate) {
        this.handoverDate = handoverDate;
    }

    /**
     * 创建人ID
     * @return input_Person_Id 创建人ID
     */
    public Integer getInputPersonId() {
        return inputPersonId;
    }

    /**
     * 创建人ID
     * @param inputPersonId 创建人ID
     */
    public void setInputPersonId(Integer inputPersonId) {
        this.inputPersonId = inputPersonId;
    }

    /**
     * 创建时间
     * @return input_Date 创建时间
     */
    public Date getInputDate() {
        return inputDate;
    }

    /**
     * 创建时间
     * @param inputDate 创建时间
     */
    public void setInputDate(Date inputDate) {
        this.inputDate = inputDate;
    }

    /**
     * 更新人ID
     * @return edit_Person_Id 更新人ID
     */
    public Integer getEditPersonId() {
        return editPersonId;
    }

    /**
     * 更新人ID
     * @param editPersonId 更新人ID
     */
    public void setEditPersonId(Integer editPersonId) {
        this.editPersonId = editPersonId;
    }

    /**
     * 更新时间
     * @return edit_Date 更新时间
     */
    public Date getEditDate() {
        return editDate;
    }

    /**
     * 更新时间
     * @param editDate 更新时间
     */
    public void setEditDate(Date editDate) {
        this.editDate = editDate;
    }

    /**
     * 仓房编号
     * @return house_id 仓房编号
     */
    public String getHouseId() {
        return houseId;
    }

    /**
     * 仓房编号
     * @param houseId 仓房编号
     */
    public void setHouseId(String houseId) {
        this.houseId = houseId == null ? null : houseId.trim();
    }

    /**
     * 公司id
     * @return province_Id 公司id
     */
    public Integer getProvinceId() {
        return provinceId;
    }

    /**
     * 公司id
     * @param provinceId 公司id
     */
    public void setProvinceId(Integer provinceId) {
        this.provinceId = provinceId;
    }

    /**
     * 城市id
     * @return city_Id 城市id
     */
    public Integer getCityId() {
        return cityId;
    }

    /**
     * 城市id
     * @param cityId 城市id
     */
    public void setCityId(Integer cityId) {
        this.cityId = cityId;
    }

    /**
     * 所属库id
     * @return grain_Id 所属库id
     */
    public Integer getGrainId() {
        return grainId;
    }

    /**
     * 所属库id
     * @param grainId 所属库id
     */
    public void setGrainId(Integer grainId) {
        this.grainId = grainId;
    }

    /**
     * 所属库名称
     * @return depot_name 所属库名称
     */
    public String getDepotName() {
        return depotName;
    }

    /**
     * 所属库名称
     * @param depotName 所属库名称
     */
    public void setDepotName(String depotName) {
        this.depotName = depotName == null ? null : depotName.trim();
    }

    /**
     * 头像
     * @return avator_Url 头像
     */
    public String getAvatorUrl() {
        return avatorUrl;
    }

    /**
     * 头像
     * @param avatorUrl 头像
     */
    public void setAvatorUrl(String avatorUrl) {
        this.avatorUrl = avatorUrl == null ? null : avatorUrl.trim();
    }

    /**
     * 民族
     * @return nation 民族
     */
    public Integer getNation() {
        return nation;
    }

    /**
     * 民族
     * @param nation 民族
     */
    public void setNation(Integer nation) {
        this.nation = nation;
    }

    /**
     * 入党时间
     * @return isdepartment_time 入党时间
     */
    public Date getIsdepartmentTime() {
        return isdepartmentTime;
    }

    /**
     * 入党时间
     * @param isdepartmentTime 入党时间
     */
    public void setIsdepartmentTime(Date isdepartmentTime) {
        this.isdepartmentTime = isdepartmentTime;
    }

    /**
     * 政治面貌
     * @return political 政治面貌
     */
    public Integer getPolitical() {
        return political;
    }

    /**
     * 政治面貌
     * @param political 政治面貌
     */
    public void setPolitical(Integer political) {
        this.political = political;
    }

    /**
     * 同步标识(正常:NULL;更新数据:UPDATE;插入数据:INSERT)
     * @return sync_flag 同步标识(正常:NULL;更新数据:UPDATE;插入数据:INSERT)
     */
    public String getSyncFlag() {
        return syncFlag;
    }

    /**
     * 同步标识(正常:NULL;更新数据:UPDATE;插入数据:INSERT)
     * @param syncFlag 同步标识(正常:NULL;更新数据:UPDATE;插入数据:INSERT)
     */
    public void setSyncFlag(String syncFlag) {
        this.syncFlag = syncFlag == null ? null : syncFlag.trim();
    }

    /**
     * 删除标识
     * @return del_flag 删除标识
     */
    public Integer getDelFlag() {
        return delFlag;
    }

    /**
     * 删除标识
     * @param delFlag 删除标识
     */
    public void setDelFlag(Integer delFlag) {
        this.delFlag = delFlag;
    }

    public String getKeeperNames() {
        return keeperNames;
    }

    public void setKeeperNames(String keeperNames) {
        this.keeperNames = keeperNames;
    }

    /**
     * 是否涉及交流轮岗,0:是,1:否
     * @return
     */
	public String getSfsjjllg() {
		return sfsjjllg;
	}

	/**
	 * 是否涉及交流轮岗,0:是,1:否
	 * @param sfsjjllg
	 */
	public void setSfsjjllg(String sfsjjllg) {
		this.sfsjjllg = sfsjjllg;
	}

	/**
	 * 名族
	 * @return
	 */
	public Integer getMz() {
		return mz;
	}

	/**
	 * 名族
	 * @param mz
	 */
	public void setMz(Integer mz) {
		this.mz = mz;
	}

	/**
	 * 职务
	 * @return
	 */
	public String getZw() {
		return zw;
	}

	/**
	 * 职务
	 * @param zw
	 */
	public void setZw(String zw) {
		this.zw = zw;
	}

	/**
	 * 在岗状态
	 * @return
	 */
	public String getZgzt() {
		return zgzt;
	}

	/**
	 * 在岗状态
	 * @param zgzt
	 */
	public void setZgzt(String zgzt) {
		this.zgzt = zgzt;
	}

	/**
	 * 岗位性质
	 * @return
	 */
	public String getGwxz() {
		return gwxz;
	}

	/**
	 * 岗位性质
	 * @param gwxz
	 */
	public void setGwxz(String gwxz) {
		this.gwxz = gwxz;
	}

	/**
	 * 参加涉粮企业工作时间
	 * @return
	 */
	public Date getCjslqygzsj() {
		return cjslqygzsj;
	}

	/**
	 * 参加涉粮企业工作时间
	 * @param cjslqygzsj
	 */
	public void setCjslqygzsj(Date cjslqygzsj) {
		this.cjslqygzsj = cjslqygzsj;
	}

	/**
	 * 参加工作时间
	 * @return
	 */
	public Date getCjgzsj() {
		return cjgzsj;
	}

	/**
	 * 参加工作时间
	 * @param cjgzsj
	 */
	public void setCjgzsj(Date cjgzsj) {
		this.cjgzsj = cjgzsj;
	}

	/**
	 * 领导班子成员/关键部门负责人
	 * @return
	 */
	public String getCyfzr() {
		return cyfzr;
	}

	/**
	 * 领导班子成员/关键部门负责人
	 * @param cyfzr
	 */
	public void setCyfzr(String cyfzr) {
		this.cyfzr = cyfzr;
	}

	/**
	 * 岗位类型
	 * @return
	 */
	public String getGwlb() {
		return gwlb;
	}

	/**
	 * 岗位类型
	 * @param gwlb
	 */
	public void setGwlb(String gwlb) {
		this.gwlb = gwlb;
	}

}