package com.chinaitop.depot.basic.model;

import java.util.Date;

import com.fasterxml.jackson.annotation.JsonFormat;

public class BasicKeeperEducation {
    private Integer id;

    private Integer keeperId;

    private Integer datatype;

    private Integer type;

    private Integer occupation;

    private String college;

    private String department;

    private Integer education;

    private Integer degree;

    private Integer degreeDetailed;

    private String rank;

    private String issueFacility;

    private Date issueTime;

    private String sfwslzy;

    private String zsbh;

    private String rych;
    
    private Integer orgId;

    private String fzywlx;

    private String filePath;

    @JsonFormat(shape = JsonFormat.Shape.STRING, pattern = "yyyy-MM-dd", timezone = "GMT+8")
    private Date fzywsj;

    /**
     * 
     * @return id 
     */
    public Integer getId() {
        return id;
    }

    /**
     * 
     * @param id 
     */
    public void setId(Integer id) {
        this.id = id;
    }

    /**
     * 保管员id
     * @return keeper_id 保管员id
     */
    public Integer getKeeperId() {
        return keeperId;
    }

    /**
     * 保管员id
     * @param keeperId 保管员id
     */
    public void setKeeperId(Integer keeperId) {
        this.keeperId = keeperId;
    }

    /**
     * 数据类型(1.学历学位信息，2.技能等级，3.职称和荣誉称号，4.上岗及其他证书，5.交流轮岗)
     * @return dataType 数据类型(1.学历学位信息，2.技能等级，3.职称和荣誉称号，4.上岗及其他证书，5.交流轮岗)
     */
    public Integer getDatatype() {
        return datatype;
    }

    /**
     * 数据类型(1.学历学位信息，2.技能等级，3.职称和荣誉称号，4.上岗及其他证书，5.交流轮岗)
     * @param datatype 数据类型(1.学历学位信息，2.技能等级，3.职称和荣誉称号，4.上岗及其他证书，5.交流轮岗)
     */
    public void setDatatype(Integer datatype) {
        this.datatype = datatype;
    }

    /**
     * 学历类型:0:全日制;1:在职教育;2:技术职称;3:职业资格
     * @return type 学历类型:0:全日制;1:在职教育;2:技术职称;3:职业资格
     */
    public Integer getType() {
        return type;
    }

    /**
     * 学历类型:0:全日制;1:在职教育;2:技术职称;3:职业资格
     * @param type 学历类型:0:全日制;1:在职教育;2:技术职称;3:职业资格
     */
    public void setType(Integer type) {
        this.type = type;
    }

    /**
     * 职业
     * @return occupation 职业
     */
    public Integer getOccupation() {
        return occupation;
    }

    /**
     * 职业
     * @param occupation 职业
     */
    public void setOccupation(Integer occupation) {
        this.occupation = occupation;
    }

    /**
     * 毕业院校
     * @return college 毕业院校
     */
    public String getCollege() {
        return college;
    }

    /**
     * 毕业院校
     * @param college 毕业院校
     */
    public void setCollege(String college) {
        this.college = college == null ? null : college.trim();
    }

    /**
     * 专业
     * @return department 专业
     */
    public String getDepartment() {
        return department;
    }

    /**
     * 专业
     * @param department 专业
     */
    public void setDepartment(String department) {
        this.department = department == null ? null : department.trim();
    }

    /**
     * 学历等级
     * @return education 学历等级
     */
    public Integer getEducation() {
        return education;
    }

    /**
     * 学历等级
     * @param education 学历等级
     */
    public void setEducation(Integer education) {
        this.education = education;
    }

    /**
     * 学位
     * @return degree 学位
     */
    public Integer getDegree() {
        return degree;
    }

    /**
     * 学位
     * @param degree 学位
     */
    public void setDegree(Integer degree) {
        this.degree = degree;
    }

    /**
     * 学位明细
     * @return degree_detailed 学位明细
     */
    public Integer getDegreeDetailed() {
        return degreeDetailed;
    }

    /**
     * 学位明细
     * @param degreeDetailed 学位明细
     */
    public void setDegreeDetailed(Integer degreeDetailed) {
        this.degreeDetailed = degreeDetailed;
    }

    /**
     * 等级
     * @return rank 等级
     */
    public String getRank() {
        return rank;
    }

    /**
     * 等级
     * @param rank 等级
     */
    public void setRank(String rank) {
        this.rank = rank;
    }

    /**
     * 颁证机构
     * @return issue_facility 颁证机构
     */
    public String getIssueFacility() {
        return issueFacility;
    }

    /**
     * 颁证机构
     * @param issueFacility 颁证机构
     */
    public void setIssueFacility(String issueFacility) {
        this.issueFacility = issueFacility == null ? null : issueFacility.trim();
    }

    /**
     * 颁证时间
     * @return issue_time 颁证时间
     */
    public Date getIssueTime() {
        return issueTime;
    }

    /**
     * 颁证时间
     * @param issueTime 颁证时间
     */
    public void setIssueTime(Date issueTime) {
        this.issueTime = issueTime;
    }

    /**
     * 是否为涉粮专业,0:是,1:否
     * @return
     */
	public String getSfwslzy() {
		return sfwslzy;
	}

	/**
	 * 是否为涉粮专业,0:是,1:否
	 * @param sfwslzy
	 */
	public void setSfwslzy(String sfwslzy) {
		this.sfwslzy = sfwslzy;
	}

	/**
	 * 证书编号
	 * @return
	 */
	public String getZsbh() {
		return zsbh;
	}

	/**
	 * 证书编号
	 * @param zsbh
	 */
	public void setZsbh(String zsbh) {
		this.zsbh = zsbh;
	}

	/**
	 * 荣誉称号
	 * @return
	 */
	public String getRych() {
		return rych;
	}

	/**
	 * 荣誉称号
	 * @param rych
	 */
	public void setRych(String rych) {
		this.rych = rych;
	}

	public Integer getOrgId() {
		return orgId;
	}

	public void setOrgId(Integer orgId) {
		this.orgId = orgId;
	}

	/**
	 * 负责（分管）业务类型
	 * @return
	 */
	public String getFzywlx() {
		return fzywlx;
	}

	/**
	 * 负责（分管）业务类型
	 * @param fzywlx
	 */
	public void setFzywlx(String fzywlx) {
		this.fzywlx = fzywlx;
	}

	/**
	 * 负责（分管）业务时间
	 * @return
	 */
	public Date getFzywsj() {
		return fzywsj;
	}

	/**
	 * 负责（分管）业务时间
	 * @param fzywsj
	 */
	public void setFzywsj(Date fzywsj) {
		this.fzywsj = fzywsj;
	}

	/**
	 * 附件路径
	 * @return
	 */
	public String getFilePath() {
		return filePath;
	}

	/**
	 * 附件路径
	 * @param filePath
	 */
	public void setFilePath(String filePath) {
		this.filePath = filePath;
	}
}