package com.chinaitop.depot.basic.model;

import java.math.BigDecimal;
import java.util.Date;

public class BasicTank {
    private String id;

    private String storagetankCode;

    private String storagetankName;

    private String orgCode;

    private BigDecimal tankCapacity;

    private Date createdate;

    private Integer facilitiesType;

    private Integer heatingType;

    private Integer tankType;

    private BigDecimal diameter;

    private BigDecimal height;

    private Date builddate;

    private Integer checkWay;

    private Integer weldWay;

    private Integer tankApply;

    private Integer tankStatus;

    private String libraryType;

    private Integer orgId;

    private Integer delFlag;

    private Date updatetime;

    private BigDecimal bottomArea;

    private BigDecimal designHeight;

    private BigDecimal oilHeight;

    private BigDecimal insportHeight;

    private String tankChart;

    private String tanklibChart;

    private String basicTruckType;

    private String keepNames;

    private String agentDepotName;

    private String crkStatus;

    private String ygdm;

    private String ygajdm;

    private String lylx;
    
    private String sptDataid;
    
    //库区标准编码
    private String kqdm;
    //油罐货位欸标准编码
    private String yghwdm;

    /**
     * 建设单位
     */
    private String jsdw;

    /**
     * 设计单位
     */
    private String sjdw;

    /**
     * 监理单位
     */
    private String jldw;

    /**
     * 油罐id
     * @return id 油罐id
     */
    public String getId() {
        return id;
    }

    /**
     * 油罐id
     * @param id 油罐id
     */
    public void setId(String id) {
        this.id = id == null ? null : id.trim();
    }

    /**
     * 油罐编码
     * @return storageTank_code 油罐编码
     */
    public String getStoragetankCode() {
        return storagetankCode;
    }

    /**
     * 油罐编码
     * @param storagetankCode 油罐编码
     */
    public void setStoragetankCode(String storagetankCode) {
        this.storagetankCode = storagetankCode == null ? null : storagetankCode.trim();
    }

    /**
     * 油罐名称
     * @return storageTank_name 油罐名称
     */
    public String getStoragetankName() {
        return storagetankName;
    }

    /**
     * 油罐名称
     * @param storagetankName 油罐名称
     */
    public void setStoragetankName(String storagetankName) {
        this.storagetankName = storagetankName == null ? null : storagetankName.trim();
    }

    /**
     * 库区编码
     * @return org_code 库区编码
     */
    public String getOrgCode() {
        return orgCode;
    }

    /**
     * 库区编码
     * @param orgCode 库区编码
     */
    public void setOrgCode(String orgCode) {
        this.orgCode = orgCode == null ? null : orgCode.trim();
    }

    /**
     * 油罐容量(吨)
     * @return tank_capacity 油罐容量(吨)
     */
    public BigDecimal getTankCapacity() {
        return tankCapacity;
    }

    /**
     * 油罐容量(吨)
     * @param tankCapacity 油罐容量(吨)
     */
    public void setTankCapacity(BigDecimal tankCapacity) {
        this.tankCapacity = tankCapacity;
    }

    /**
     * 创建日期
     * @return createDate 创建日期
     */
    public Date getCreatedate() {
        return createdate;
    }

    /**
     * 创建日期
     * @param createdate 创建日期
     */
    public void setCreatedate(Date createdate) {
        this.createdate = createdate;
    }

    /**
     * 油罐及附属设施是否完好(1：是,0：否,9:其他或不确定)
     * @return facilities_type 油罐及附属设施是否完好(1：是,0：否,9:其他或不确定)
     */
    public Integer getFacilitiesType() {
        return facilitiesType;
    }

    /**
     * 油罐及附属设施是否完好(1：是,0：否,9:其他或不确定)
     * @param facilitiesType 油罐及附属设施是否完好(1：是,0：否,9:其他或不确定)
     */
    public void setFacilitiesType(Integer facilitiesType) {
        this.facilitiesType = facilitiesType;
    }

    /**
     * 有无加热装置(1：有,0：无,9:其他或不确定)
     * @return heating_type 有无加热装置(1：有,0：无,9:其他或不确定)
     */
    public Integer getHeatingType() {
        return heatingType;
    }

    /**
     * 有无加热装置(1：有,0：无,9:其他或不确定)
     * @param heatingType 有无加热装置(1：有,0：无,9:其他或不确定)
     */
    public void setHeatingType(Integer heatingType) {
        this.heatingType = heatingType;
    }

    /**
     * 油罐类型(1：立式油罐,2：卧式油罐,3：油槽(池),4：地下油罐,5：其他)
     * @return tank_type 油罐类型(1：立式油罐,2：卧式油罐,3：油槽(池),4：地下油罐,5：其他)
     */
    public Integer getTankType() {
        return tankType;
    }

    /**
     * 油罐类型(1：立式油罐,2：卧式油罐,3：油槽(池),4：地下油罐,5：其他)
     * @param tankType 油罐类型(1：立式油罐,2：卧式油罐,3：油槽(池),4：地下油罐,5：其他)
     */
    public void setTankType(Integer tankType) {
        this.tankType = tankType;
    }

    /**
     * 罐内直径
     * @return diameter 罐内直径
     */
    public BigDecimal getDiameter() {
        return diameter;
    }

    /**
     * 罐内直径
     * @param diameter 罐内直径
     */
    public void setDiameter(BigDecimal diameter) {
        this.diameter = diameter;
    }

    /**
     * 罐内高度
     * @return height 罐内高度
     */
    public BigDecimal getHeight() {
        return height;
    }

    /**
     * 罐内高度
     * @param height 罐内高度
     */
    public void setHeight(BigDecimal height) {
        this.height = height;
    }

    /**
     * 建造日期
     * @return buildDate 建造日期
     */
    public Date getBuilddate() {
        return builddate;
    }

    /**
     * 建造日期
     * @param builddate 建造日期
     */
    public void setBuilddate(Date builddate) {
        this.builddate = builddate;
    }

    /**
     * 检定方式(1：标定,0：非标定,9:其他或不确定)
     * @return check_way 检定方式(1：标定,0：非标定,9:其他或不确定)
     */
    public Integer getCheckWay() {
        return checkWay;
    }

    /**
     * 检定方式(1：标定,0：非标定,9:其他或不确定)
     * @param checkWay 检定方式(1：标定,0：非标定,9:其他或不确定)
     */
    public void setCheckWay(Integer checkWay) {
        this.checkWay = checkWay;
    }

    /**
     * 焊接方式(1：对接,2：搭接,9:其他或不确定)
     * @return weld_way 焊接方式(1：对接,2：搭接,9:其他或不确定)
     */
    public Integer getWeldWay() {
        return weldWay;
    }

    /**
     * 焊接方式(1：对接,2：搭接,9:其他或不确定)
     * @param weldWay 焊接方式(1：对接,2：搭接,9:其他或不确定)
     */
    public void setWeldWay(Integer weldWay) {
        this.weldWay = weldWay;
    }

    /**
     * 油罐使用情况(1：空仓,2：占用,3：满货位,4：入库中,5：出库中,6：维修,9：其他)
     * @return tank_apply 油罐使用情况(1：空仓,2：占用,3：满货位,4：入库中,5：出库中,6：维修,9：其他)
     */
    public Integer getTankApply() {
        return tankApply;
    }

    /**
     * 油罐使用情况(1：空仓,2：占用,3：满货位,4：入库中,5：出库中,6：维修,9：其他)
     * @param tankApply 油罐使用情况(1：空仓,2：占用,3：满货位,4：入库中,5：出库中,6：维修,9：其他)
     */
    public void setTankApply(Integer tankApply) {
        this.tankApply = tankApply;
    }

    /**
     * 油罐状态(1：完好,2：需小修,3：需大修,4：待报废,5：待拆除,6：长期闲置,9：其他)
     * @return tank_status 油罐状态(1：完好,2：需小修,3：需大修,4：待报废,5：待拆除,6：长期闲置,9：其他)
     */
    public Integer getTankStatus() {
        return tankStatus;
    }

    /**
     * 油罐状态(1：完好,2：需小修,3：需大修,4：待报废,5：待拆除,6：长期闲置,9：其他)
     * @param tankStatus 油罐状态(1：完好,2：需小修,3：需大修,4：待报废,5：待拆除,6：长期闲置,9：其他)
     */
    public void setTankStatus(Integer tankStatus) {
        this.tankStatus = tankStatus;
    }

    /**
     * 库类型，0.主粮库，1.代储点粮库
     * @return library_type 库类型，0.主粮库，1.代储点粮库
     */
    public String getLibraryType() {
        return libraryType;
    }

    /**
     * 库类型，0.主粮库，1.代储点粮库
     * @param libraryType 库类型，0.主粮库，1.代储点粮库
     */
    public void setLibraryType(String libraryType) {
        this.libraryType = libraryType == null ? null : libraryType.trim();
    }

    /**
     * 库级id
     * @return org_id 库级id
     */
    public Integer getOrgId() {
        return orgId;
    }

    /**
     * 库级id
     * @param orgId 库级id
     */
    public void setOrgId(Integer orgId) {
        this.orgId = orgId;
    }

    /**
     * 删除状态(1.正常，2.删除)
     * @return del_flag 删除状态(1.正常，2.删除)
     */
    public Integer getDelFlag() {
        return delFlag;
    }

    /**
     * 删除状态(1.正常，2.删除)
     * @param delFlag 删除状态(1.正常，2.删除)
     */
    public void setDelFlag(Integer delFlag) {
        this.delFlag = delFlag;
    }

    /**
     * 
     * @return updatetime 
     */
    public Date getUpdatetime() {
        return updatetime;
    }

    /**
     * 
     * @param updatetime 
     */
    public void setUpdatetime(Date updatetime) {
        this.updatetime = updatetime;
    }

    /**
     * 
     * @return bottom_area 
     */
    public BigDecimal getBottomArea() {
        return bottomArea;
    }

    /**
     * 
     * @param bottomArea 
     */
    public void setBottomArea(BigDecimal bottomArea) {
        this.bottomArea = bottomArea;
    }

    /**
     * 
     * @return design_height 
     */
    public BigDecimal getDesignHeight() {
        return designHeight;
    }

    /**
     * 
     * @param designHeight 
     */
    public void setDesignHeight(BigDecimal designHeight) {
        this.designHeight = designHeight;
    }

    /**
     * 
     * @return oil_height 
     */
    public BigDecimal getOilHeight() {
        return oilHeight;
    }

    /**
     * 
     * @param oilHeight 
     */
    public void setOilHeight(BigDecimal oilHeight) {
        this.oilHeight = oilHeight;
    }

    /**
     * 
     * @return insport_height 
     */
    public BigDecimal getInsportHeight() {
        return insportHeight;
    }

    /**
     * 
     * @param insportHeight 
     */
    public void setInsportHeight(BigDecimal insportHeight) {
        this.insportHeight = insportHeight;
    }

    /**
     * 
     * @return tank_chart 
     */
    public String getTankChart() {
        return tankChart;
    }

    /**
     * 
     * @param tankChart 
     */
    public void setTankChart(String tankChart) {
        this.tankChart = tankChart == null ? null : tankChart.trim();
    }

    /**
     * 
     * @return tanklib_chart 
     */
    public String getTanklibChart() {
        return tanklibChart;
    }

    /**
     * 
     * @param tanklibChart 
     */
    public void setTanklibChart(String tanklibChart) {
        this.tanklibChart = tanklibChart == null ? null : tanklibChart.trim();
    }

    /**
     * 
     * @return basic_truck_type 
     */
    public String getBasicTruckType() {
        return basicTruckType;
    }

    /**
     * 
     * @param basicTruckType 
     */
    public void setBasicTruckType(String basicTruckType) {
        this.basicTruckType = basicTruckType == null ? null : basicTruckType.trim();
    }

    public String getKeepNames() {
        return keepNames;
    }

    public void setKeepNames(String keepNames) {
        this.keepNames = keepNames;
    }

    public String getAgentDepotName() {
        return agentDepotName;
    }

    public void setAgentDepotName(String agentDepotName) {
        this.agentDepotName = agentDepotName;
    }

	public String getCrkStatus() {
		return crkStatus;
	}

	public void setCrkStatus(String crkStatus) {
		this.crkStatus = crkStatus;
	}

	public String getYgdm() {
		return ygdm;
	}

	public void setYgdm(String ygdm) {
		this.ygdm = ygdm;
	}

	public String getYgajdm() {
		return ygajdm;
	}

	public void setYgajdm(String ygajdm) {
		this.ygajdm = ygajdm;
	}

	/**
	 * 粮油类型(0:原粮,1:成品粮)
	 * @return 粮油类型
	 */
	public String getLylx() {
		return lylx;
	}

	/**
	 * 粮油类型(0:原粮,1:成品粮)
	 * @param lylx 粮油类型
	 */
	public void setLylx(String lylx) {
		this.lylx = lylx == null ? null : lylx.trim();
	}

    public String getJsdw() {
        return jsdw;
    }

    public void setJsdw(String jsdw) {
        this.jsdw = jsdw;
    }

    public String getSjdw() {
        return sjdw;
    }

    public void setSjdw(String sjdw) {
        this.sjdw = sjdw;
    }

    public String getJldw() {
        return jldw;
    }

    public void setJldw(String jldw) {
        this.jldw = jldw;
    }

    /**
     * 市平台油罐基础数据主键ID
     * @return
     */
	public String getSptDataid() {
		return sptDataid;
	}

	/**
	 * 市平台油罐基础数据主键ID
	 * @param sptDataid
	 */
	public void setSptDataid(String sptDataid) {
		this.sptDataid = sptDataid;
	}

	/**
	 * 库区标准代码
	 * @return
	 */
	public String getKqdm() {
		return kqdm;
	}

	/**
	 * 库区标准代码
	 * @param kqdm
	 */
	public void setKqdm(String kqdm) {
		this.kqdm = kqdm;
	}

	/**
	 * 油罐货位欸标准编码
	 * @return
	 */
	public String getYghwdm() {
		return yghwdm;
	}

	/**
	 * 油罐货位欸标准编码
	 * @param yghwdm
	 */
	public void setYghwdm(String yghwdm) {
		this.yghwdm = yghwdm;
	}
    
}