/**
 * 
 */
package com.chinaitop.depot.basic.service;

import java.util.List;
import java.util.Map;

import org.springframework.stereotype.Repository;

import com.chinaitop.depot.basic.model.BasicCodeRule;
import com.chinaitop.depot.basic.model.BasicCodeRuleDetail;
import com.chinaitop.depot.basic.model.BasicCodeRuleExample;

/**
 * <p>Title: BasicCodeRuleService</p>
 * <p>Description: </p>
 * @author yaoyabin
 * @date 2017年12月15日 上午10:59:56
 */
@Repository
public interface BasicCodeRuleService {

    /**
     * 查询.
     * @param pageNum
     * @param pageSize
     * @param orgId 单位ID
     * @return
     */
    List<BasicCodeRule> queryByExample(Integer pageNum, Integer pageSize,
            Integer orgId);

    /**
     * @param id
     * @return
     */
    BasicCodeRule findById(Integer id);

    /**
     * 新增
     * @param codeRule
     * @param codeRuleDetailList
     * @param userId
     * @param orgId
     * @return
     */
    Map<String, Object> add(BasicCodeRule codeRule,
            List<BasicCodeRuleDetail> codeRuleDetailList, Integer userId,
            Integer orgId);

    /**
     * @param codeRule
     * @param codeRuleDetailList
     */
    void update(BasicCodeRule codeRule,
            List<BasicCodeRuleDetail> codeRuleDetailList);

    /**
     * @param id
     */
    void remove(Integer id);

    /**
     * @param pageNum
     * @param pageSize
     * @param bid
     * @return
     */
    List<BasicCodeRuleDetail> getDetailList(Integer pageNum, Integer pageSize,
            Integer bid);

    /**
     * @param id
     * @return
     */
    List<BasicCodeRuleDetail> getDetailList(Integer id);

    /**
     * 根据编码类型枚举id和orgId获取编码.
     * @param codeRuleTypeEnumId 编码类型枚举id.
     * @param orgId
     * @return
     * @throws Exception
     */
    String getCode(Integer codeRuleTypeEnumId, Integer orgId) throws Exception;

    /**
     * 根据新增编码名称进行查询是否存在相同编码名称
     * @param example
     * @return
     */
	List<BasicCodeRule> findCodeName(BasicCodeRuleExample example);
}
