package com.chinaitop.depot.basic.service;

import java.util.List;
import java.util.Map;

import com.chinaitop.depot.basic.model.BasicEnum;
import com.chinaitop.depot.basic.model.BasicEnumExample;

public interface BasicEnumService {

	/**
	 * 新增枚举大类
	 * @param basicEnum
	 * @throws Exception
	 */
	public BasicEnum saveEnum(BasicEnum basicEnum) throws Exception;

	/**
	 * 删除枚举大类
	 * @param id
	 * @throws Exception
	 */
	public void removeEnum(Integer id) throws Exception;

	/**
	 * 修改枚举大类
	 * @param basicEnum
	 * @throws Exception
	 */
	public void updateEnum(BasicEnum basicEnum) throws Exception;

	/**
	 * 按照ID查询一条枚举大类信息
	 * @param basicEnum
	 * @throws Exception
	 */
	public BasicEnum findByParmeryKeyEnum(Integer id) throws Exception;

	/**
	 * 按照条件查询枚举大类信息
	 * @param basicEnum
	 * @throws Exception
	 */
	public List<BasicEnum> findConditionEnum(BasicEnumExample basicEnumExample) throws Exception;

	/**
	 * 按父级ID获取所有枚举数据
	 * @return
	 * @throws Exception
	 */
	public Map<Integer, List<BasicEnum>> findEnumObjParentId() throws Exception;

	/**
	 * 按数据ID获取所有枚举数据
	 * @return
	 * @throws Exception
	 */
	public Map<Object, Object> findEnumObjEnumId() throws Exception;

	/**
	 * 获取以Id为对象的字典值
	 * @return
	 */
	List<BasicEnum> queryByTree();
	
	/**
	 * 获取所有子节点
	 * @param enumid
	 * @return
	 */
	List<BasicEnum> queryAllChildren(Integer enumid,String planManage);

	/**
     * 导入
     * @param list
     */
	String importData(List<List<String>> list);

	/**
	 * 根据名称和父ID获取ID
	 * 
	 * @param parentId 父ID
	 * @param enumName 字典名称
	 * @param code 国标编码前几位模糊值
	 * @return
	 * @throws Exception
	 */
	Map<String, Object> getIdByNameAndParentId(Integer parentId, String enumName, String code) throws Exception;

	/**
	 * 按照父节点和国标编码查找一条字典数据
	 * @param parentid
	 * @param gbcode
	 * @return
	 * @throws Exception
	 */
	public BasicEnum getBasicEnum(Integer parentid, String gbcode) throws Exception;

	/**
	 * 递归查询树结构
	 * @param parentId 字典父级ID
	 * @param notParentId 要排除的父级ID
	 * @param notEnumId 要排除的字典ID
	 * @return
	 */
	Map<String, Object> findCondition(Integer parentId, Integer notParentId, Integer notEnumId);
}
