package com.chinaitop.depot.basic.service;

import com.chinaitop.depot.basic.model.BasicKeeperHouse;
import com.chinaitop.depot.basic.model.BasicKeeperHouseExample;

import java.util.List;

public interface BasicKeeperHouseService {

	/**
	 * 新增
	 * @param keeperHouse
	 */
	void save(BasicKeeperHouse keeperHouse);

	/**
	 * 删除
	 * @param example
	 */
	void delete(BasicKeeperHouseExample example);

	/**
	 * 按条件查询
	 * @param example
	 * @return
	 */
	List<BasicKeeperHouse> findCondition(BasicKeeperHouseExample example);

	/**
	 * 通过员工ID和仓房ID删除一条数据
	 * 
	 * @param keeperId 员工ID
	 * @param houseId 仓房ID
	 */
	void deleteByKeeperIdAndHouseId(Integer keeperId,Integer houseId);

	/**
	 * 通过员工ID和仓房ID查询一条数据
	 * 
	 * @param keeperId 员工ID
	 * @param houseId 仓房ID
	 * @return
	 */
	BasicKeeperHouse getHouseKeeperBykeeperIdAndHouseId(Integer keeperId,Integer houseId);

	/**
	 * 获取一个仓房的所有保管员的员工数据ID
	 * 
	 * @param orgIdId 单位ID
	 * @param houseId 仓房ID
	 * @return
	 */
	List<Integer> getKeeperId(Integer orgId,Integer houseId);

}
