package com.chinaitop.depot.basic.service;

import java.util.List;
import java.util.Map;

import javax.servlet.http.HttpServletRequest;

import com.alibaba.fastjson.JSONObject;
import com.chinaitop.depot.basic.model.BasicTank;
import com.chinaitop.depot.basic.model.BasicTankExample;

public interface BasicTankService {


    List<BasicTank> findBasicTank(BasicTankExample example);
    List<BasicTank> findBasicTankNew(Map<String, Object> map);

    void saveOrEdit(HttpServletRequest request, BasicTank basicTank,Integer orgId);

    BasicTank findByPrimary(String id);

    void updateBasicTank(String id, Integer delFlag) throws Exception;

    Boolean findStorageTankCodeList(BasicTankExample basicTankExample, String id);

    String importData(List<List<String>> list, JSONObject user,String orgCode);

    /**
     * 根据仓房ID获取当前仓房的保管员名称
	 *
     * @param id
     * @param orgId
     * @param b
     * @return
     */
	String getStorehouseKeeper(String id, Integer orgId, boolean b);

	/**
	 * 更新油罐数据
	 * 
	 * @param request
	 * @param tankJson
	 * @param orgId
	 * @return
	 * @throws Exception
	 */
	Map<String, Object> updateOrSave(HttpServletRequest request, String tankJson, Integer orgId) throws Exception;

	/**
	 * 修改油罐的出入库状态
	 * @param basicTank
	 */
	void updateTankCrkStatus(BasicTank basicTank) throws Exception;

	/**
	 * 接收市平台传过来的油罐基础数据(修改和新增)
	 * @param datas
	 * @return
	 * @throws Exception 
	 */
	Map<String, String> saveOrUpdateSptTankData(String datas) throws Exception;

}
