package com.chinaitop.depot.basic.service.impl;

import java.util.ArrayList;
import java.util.List;

import javax.annotation.Resource;

import org.springframework.stereotype.Service;

import com.chinaitop.depot.basic.mapper.BasicKeeperHouseMapper;
import com.chinaitop.depot.basic.model.BasicKeeperHouse;
import com.chinaitop.depot.basic.model.BasicKeeperHouseExample;
import com.chinaitop.depot.basic.service.BasicKeeperHouseService;

@Service
public class BasicKeeperHouseServiceImpl implements BasicKeeperHouseService {

	@Resource
	private BasicKeeperHouseMapper mapper;

	@Override
	public void save(BasicKeeperHouse keeperHouse) {
		mapper.insertSelective(keeperHouse);
	}

	@Override
	public void delete(BasicKeeperHouseExample example) {
		mapper.deleteByExample(example);
	}

	@Override
	public List<BasicKeeperHouse> findCondition(BasicKeeperHouseExample example) {
		return mapper.selectByExample(example);
	}

	@Override
	public void deleteByKeeperIdAndHouseId(Integer keeperId, Integer houseId) {
		 mapper.deleteByKeeperIdAndHouseId(keeperId,houseId);
	}

	@Override
	public BasicKeeperHouse getHouseKeeperBykeeperIdAndHouseId(Integer keeperId, Integer houseId) {
		return  mapper.getHouseKeeperBykeeperIdAndHouseId(keeperId,houseId);
	}

	@Override
	public List<Integer> getKeeperId(Integer orgId, Integer houseId) {

		BasicKeeperHouseExample keepHouseExample = new BasicKeeperHouseExample();
		BasicKeeperHouseExample.Criteria criteria = keepHouseExample.createCriteria();
		criteria.andHouseIdEqualTo(houseId);
		if (null != orgId) {
			criteria.andOrgIdEqualTo(orgId);
		}
		List<BasicKeeperHouse> keepHouse_list = mapper.selectByExample(keepHouseExample);

		/* 获取保管这个仓房的多有人的员工ID */
		List<Integer> keep_list = null;
		if (null != keepHouse_list && keepHouse_list.size() > 0) {
			keep_list = new ArrayList<Integer>();
			for (BasicKeeperHouse keeperHouse : keepHouse_list) {
				keep_list.add(keeperHouse.getKeeperId());
			}
		}
		return keep_list;
	}

}
