package com.chinaitop.depot.basic.service.impl;

import java.math.BigDecimal;
import java.text.SimpleDateFormat;
import java.util.Date;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import java.util.regex.Matcher;
import java.util.regex.Pattern;

import javax.annotation.Resource;
import javax.servlet.http.HttpServletRequest;

import org.apache.commons.lang.ObjectUtils;
import org.apache.commons.lang3.StringUtils;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import com.alibaba.fastjson.JSONObject;
import com.chinaitop.depot.basic.mapper.BasicEnumMapper;
import com.chinaitop.depot.basic.mapper.BasicStorehouseMapper;
import com.chinaitop.depot.basic.mapper.BasicTankHwMapper;
import com.chinaitop.depot.basic.mapper.BasicTankMapper;
import com.chinaitop.depot.basic.mapper.BasicWarehouseMapper;
import com.chinaitop.depot.basic.model.BasicEnum;
import com.chinaitop.depot.basic.model.BasicStorehouse;
import com.chinaitop.depot.basic.model.BasicTank;
import com.chinaitop.depot.basic.model.BasicTankExample;
import com.chinaitop.depot.basic.model.BasicTankHw;
import com.chinaitop.depot.basic.service.BasicEnumService;
import com.chinaitop.depot.basic.service.BasicKeeperHouseService;
import com.chinaitop.depot.basic.service.BasicKeeperService;
import com.chinaitop.depot.basic.service.BasicStorehouseService;
import com.chinaitop.depot.basic.service.BasicTankService;
import com.chinaitop.depot.system.mapper.OrgInfoMapper;
import com.chinaitop.depot.system.model.OrgInfo;
import com.chinaitop.depot.utils.BusinessUtils;
import com.chinaitop.utils.ParameterUtil;
import com.fasterxml.jackson.databind.ObjectMapper;

@Service
public class BasicTankServiceImpl implements BasicTankService {

	@Resource
	private BasicTankMapper basicTankMapper;

	@Resource
	private BasicTankHwMapper basicTankHwMapper;

	@Resource
	private BasicEnumMapper enumMapper;

	@Resource
	private BasicEnumService basicEnumService;

	@Resource
	private BasicStorehouseMapper basicStorehouseMapper;
	
	@Resource
	private BasicStorehouseService basicStorehouseService;

	@Resource
	private BasicKeeperHouseService keeperHouseService;

	@Resource
	private BasicKeeperService keeperService;

	@Resource
	private BasicWarehouseMapper warehouseMapper;
	
	@Resource
	private OrgInfoMapper OrgInfoMapper;


	@Override
	public List<BasicTank> findBasicTank(BasicTankExample example) {

		List<BasicTank> basicTanks = basicTankMapper.selectByExample(example);

		return basicTanks;
	}

	@Override
	public List<BasicTank> findBasicTankNew(Map<String, Object> map) {

		List<BasicTank> basicTanks = basicTankMapper.selectByExampleNew(map);

		return basicTanks;
	}

	@Override
    public void saveOrEdit(HttpServletRequest request, BasicTank basicTank,Integer orgId) {
		basicTank.setDelFlag(1);
		basicTank.setOrgId(orgId);
		//basicTank.setUpdatetime(new Date());
		
		//组装油罐货位
		String org_obj = ObjectUtils.toString(request.getSession().getAttribute("orgInfo"),"");
		String bgdw = ""; //保管单位名称
		String dwdm = ""; //18位统一信用代码
		if(!org_obj.isEmpty()) {
			JSONObject obj = JSONObject.parseObject(org_obj);
			bgdw = ObjectUtils.toString(obj.get("orgName"), "");//保管单位默认为当前用户所在的单位
			dwdm = ObjectUtils.toString(obj.get("creditCode"), "");
		}
		BasicTankHw tankhw = new BasicTankHw();
		tankhw.setOrgId(orgId);
		//tankhw.setHwbm("01");
		tankhw.setHwmc(basicTank.getStoragetankName());
		tankhw.setHwqyrq(basicTank.getBuilddate());
		tankhw.setHwrl(basicTank.getTankCapacity());
		tankhw.setBgdw(bgdw);
		tankhw.setCzbz("i");
		tankhw.setZhgxsj(basicTank.getCreatedate());
		tankhw.setCrkStatus(basicTank.getCrkStatus());
		
		String ygbm = "";//油罐编码
		String ajbm = "";//廒间编码

		if (!"".equals(basicTank.getStoragetankCode())) {
			String code = basicTank.getStoragetankCode().toString().substring(2, 5);
			ygbm = BusinessUtils.setBZcfandygbm(dwdm, code, "1", orgId+"");
			ajbm = BusinessUtils.setBZajbm(ygbm, "", "1");
			basicTank.setYgdm(ygbm);
			basicTank.setYgajdm(ajbm);
		}
        if(basicTank.getId() == null || "".equals(basicTank.getId())){
        	BasicStorehouse storehouse = new BasicStorehouse();
        	storehouse.setStorehouseCode(basicTank.getStoragetankCode());
        	storehouse.setStorehouseName(basicTank.getStoragetankName());
        	storehouse.setOrgId(basicTank.getOrgId());
        	storehouse.setDatatype("1");
        	storehouse.setDelFlag(1);
        	storehouse.setCreatedate(new Date());
        	storehouse.setLibraryType("0");
        	storehouse.setCfbm(basicTank.getYgdm());
        	storehouse.setAjbm(basicTank.getYgajdm());
        	int count = basicStorehouseMapper.insertSelective(storehouse);
        	if (count > 0) {
//        		StringBuffer sbf = new StringBuffer();
//        		sbf.append("YG").append(UUID.randomUUID().toString().replace("-", ""));
        		basicTank.setId(storehouse.getStorehouseId().toString());
        		
        		//basicTank.sety
        		
        		basicTankMapper.insertSelective(basicTank);
        		
        		tankhw.setId(Integer.parseInt(basicTank.getId()));
        		tankhw.setHwbm(BusinessUtils.setBZhwbm(basicTank.getYgajdm(), "01"));
        		tankhw.setCzbz("u");
    			basicTankHwMapper.insertSelective(tankhw);
        	}
		}else{
			int count = basicTankMapper.updateByPrimaryKey(basicTank);
			if (!"".equals(basicTank.getStoragetankCode())) {
				tankhw.setHwbm(BusinessUtils.setBZhwbm(basicTank.getYgajdm(), "01"));
			}
			if (count > 0) {
				BasicStorehouse storehouse = new BasicStorehouse();
				storehouse.setStorehouseId(Integer.parseInt(basicTank.getId()));
				storehouse.setStorehouseName(basicTank.getStoragetankName());
				storehouse.setStorehouseCode(basicTank.getStoragetankCode());
				storehouse.setDelFlag(basicTank.getDelFlag());
				storehouse.setCfbm(basicTank.getYgdm());
	        	storehouse.setAjbm(basicTank.getYgajdm());
				basicStorehouseMapper.updateByPrimaryKeySelective(storehouse);
			}
			basicTankHwMapper.updateByPrimaryKeySelective(tankhw);

			//如果是出库或空仓，需要把当前货位的业务数据进行归档等操作
			if ("1".equals(basicTank.getCrkStatus()) || "4".equals(basicTank.getCrkStatus())) {
				Map<String, Object> lqkmap = new HashMap<String, Object>();
				lqkmap.put("storehouseId", basicTank.getId());
				lqkmap.put("orgId", basicTank.getOrgId());
				warehouseMapper.updateYlLqkGd(lqkmap);//归档原粮粮情卡
				warehouseMapper.updateCplLqkGd(lqkmap);//归档成品粮粮情卡
				warehouseMapper.updateQualitycheck(lqkmap);//归档自检数据
			}
		}
    }

    @Override
    public BasicTank findByPrimary(String id) {
        return basicTankMapper.selectByPrimaryKey(id);
    }

	@Override
	@Transactional(rollbackFor = Exception.class)
	public void updateBasicTank(String id, Integer delFlag) throws Exception {
		BasicTank basicTank = new BasicTank();
		basicTank.setId(id);
		// 启用 ： 1
		// 弃用 ： 0  当前是启用，则改成0，如果当前是弃用,则改成1
		if (delFlag == 1) {
			delFlag = 0;
		} else if (delFlag == 0) {
			delFlag = 1;
		}
		basicTank = basicTankMapper.selectByPrimaryKey(id);
		basicTank.setDelFlag(delFlag);
		int count = basicTankMapper.updateByPrimaryKeySelective(basicTank);
		if (count > 0) {
			BasicStorehouse storehouse = new BasicStorehouse();
			storehouse.setStorehouseId(Integer.parseInt(basicTank.getId()));
			storehouse.setDelFlag(basicTank.getDelFlag());
			basicStorehouseMapper.updateByPrimaryKeySelective(storehouse);
		}
		/* 更新油罐数量 */
		basicStorehouseService.editOrgChNum(basicTank.getOrgId());
	}

	@Override
	public Boolean findStorageTankCodeList(BasicTankExample basicTankExample, String id) {
		List<BasicTank>  basicTankList = basicTankMapper.selectByExample(basicTankExample);
		try {
			if(null != basicTankList && !basicTankList.isEmpty() ){
				if(id != null && !"".equals(id)){
					//id有值是修改
					BasicTank basicTank = basicTankMapper.selectByPrimaryKey(id);

					if(null != basicTank && basicTank.getStoragetankCode().equals(basicTankList.get(0).getStoragetankCode()) && basicTankList.size() > 1 ){
						return true;
					}else if (basicTankList.size() > 0){
						return true;
					}
				}else{
					if (basicTankList.size() > 0) {
						return true;
					}
				}
			}
		} catch (Exception e) {
			e.printStackTrace();
		}
		return false;
	}

    @Override
    public String importData(List<List<String>> list, JSONObject user,String orgCode) {
		Integer orgId = null;
		if (null != user) {
			orgId = Integer.parseInt(user.get("orgId") == null?"":user.get("orgId").toString());
		}

		Map<String, Integer> map = new HashMap<String, Integer>();
		BasicTank tank = null;
		String msg = "";//消息
		int len = 0;//长度

		BasicTankExample basicTankExample = new BasicTankExample();
		BasicTankExample.Criteria criteria = basicTankExample.createCriteria();
		List<BasicTank>  basicTankList = null;

		for (int i = 0; i < list.size(); i++) {
			List<String> revList = list.get(i);

			for (int j = 0; j < revList.size(); j++) {
				switch(j) {
					case 0://油罐编码
						if (ParameterUtil.isnotnull(revList.get(j))) {
							len = revList.get(j).length();
							Pattern p = Pattern.compile("YG[0-9]{3}");
                        	Matcher m = p.matcher(revList.get(j));
                        	boolean flag = m.matches();
                        	if (!flag) {
								msg = "第 "+(i+1)+" 行，油罐编码数据只能是YG加三位数字，如：YG001，";
								return msg;
							}

							if (null != revList.get(j)) {
								criteria.andStoragetankCodeEqualTo(revList.get(j));
								criteria.andOrgIdEqualTo(orgId);
							}
							basicTankList = basicTankMapper.selectByExample(basicTankExample);

							if (basicTankList.size() > 0) {
								msg = "第 "+(i+1)+" 行 油罐编码已存在，";
								return msg;
							}

							Integer mapKey = map.get(revList.get(j));
							if (mapKey == null) {
								tank = new BasicTank();
								map.put(revList.get(j), null);
								tank.setStoragetankCode(revList.get(j));
							}
						}
						break;
					case 1://油罐名称
						if (tank != null) {
							len = revList.get(j).length();
							if (len > 30) {
								msg = "第 "+(i+1)+" 行油罐名称的值的长度不能超过30！";
								return msg;
							}
							tank.setStoragetankName(revList.get(j));
						}
						break;
					case 2://油罐容量(吨)
						if (ParameterUtil.isnotnull(revList.get(j)) && tank != null) {
							len = revList.get(j).length();
							Pattern p = Pattern.compile("^(([1-9]{1}\\d*)|([0]{1}))(\\.(\\d){0,2})?$");
							Matcher m = p.matcher(revList.get(j));
							boolean flag = m.matches();
							if (!flag || len > 7) {
								msg = "第"+(i+1)+"行，油罐容量的长度包括小数位不能大于7位，小数位最多2位，";
								return msg;
							}
							tank.setOrgCode(orgCode);
							BigDecimal bd = new BigDecimal(revList.get(j));
							tank.setTankCapacity(bd);
						}
						break;
					case 3://油罐直径
						if (ParameterUtil.isnotnull(revList.get(j)) && tank != null) {
							len = revList.get(j).length();
							Pattern p = Pattern.compile("^(([1-9]{1}\\d*)|([0]{1}))(\\.(\\d){0,2})?$");
                        	Matcher m = p.matcher(revList.get(j));
                        	boolean flag = m.matches();
                        	if (!flag || len > 5) {
                        		msg = "第"+(i+1)+"行，直径的长度包括小数位不能大于5位，小数位最多2位，";
                        		return msg;
                        	}
                        	BigDecimal bd = new BigDecimal(revList.get(j));
							tank.setDiameter(bd);
						}
						break;
					case 4://高度(米)
						if (ParameterUtil.isnotnull(revList.get(j)) && tank != null) {
							len = revList.get(j).length();
							Pattern p = Pattern.compile("^(([1-9]{1}\\d*)|([0]{1}))(\\.(\\d){0,2})?$");
                        	Matcher m = p.matcher(revList.get(j));
                        	boolean flag = m.matches();
                        	if (!flag || len > 5) {
                        		msg = "第"+(i+1)+"行，高度的长度包括小数位不能大于5位，小数位最多2位，";
                        		return msg;
                        	}
                        	BigDecimal bd = new BigDecimal(revList.get(j));
							tank.setHeight(bd);
						}
						break;
					case 5://建造日期
						if (ParameterUtil.isnotnull(revList.get(j)) && tank != null) {
							boolean convertSuccess = true;
                        	SimpleDateFormat format = new SimpleDateFormat("yyyy-MM-dd");
                        	try {
                        		// 设置lenient为false. 否则SimpleDateFormat会比较宽松地验证日期，比如2007/02/29会被接受，并转换成2007/03/01
                        		format.setLenient(false);
                        		format.parse(revList.get(j));
                        	} catch (Exception e) {
                        		// 如果throw java.text.ParseException或者NullPointerException，就说明格式不对
                        		convertSuccess = false;
                        	} 
                        	if (!convertSuccess) {
                        		msg = "第"+(i+1)+"行，建造日期的格式不正确，正确格式如：2020-01-01，";
                        		return msg;
                        	}
							tank.setBuilddate(ParameterUtil.string2date(revList.get(j)));
						}
						if (tank != null) {
							BasicStorehouse storehouse = new BasicStorehouse();
				        	storehouse.setStorehouseCode(tank.getStoragetankCode());
				        	storehouse.setStorehouseName(tank.getStoragetankName());
				        	storehouse.setOrgId(orgId);
				        	storehouse.setDatatype("1");
				        	storehouse.setDelFlag(1);
				        	storehouse.setCreatedate(new Date());
				        	storehouse.setLibraryType("0");
				        	int count = basicStorehouseMapper.insertSelective(storehouse);
				        	if (count > 0) {
//				        		StringBuffer sbf = new StringBuffer();
//				        		sbf.append("YG").append(UUID.randomUUID().toString().replace("-", ""));
				        		tank.setId(storehouse.getStorehouseId().toString());
				        		//basicTankMapper.insertSelective(tank);
				        		
				        		tank.setDelFlag(1);
								tank.setOrgId(orgId);
								//StringBuffer sbf = new StringBuffer();
								//sbf.append("YG").append(UUID.randomUUID().toString().replace("-", ""));
								//tank.setId(sbf.toString().trim());
								basicTankMapper.insertSelective(tank);
				        	}
							
						}
						break;
					default :
						break;
				}

			}

		}
		return msg;
    }

	@Override
	public String getStorehouseKeeper(String id, Integer orgId, boolean flag) {
		String keeperNames = "";

		/* 获取这个仓房的所有保管员的员工ID */
		List<Integer> keep_list = keeperHouseService.getKeeperId(orgId, Integer.parseInt(id));

		//2、然后把这些人的翻译过来，展示出来
		if (null != keep_list && keep_list.size() > 0) {
			keeperNames = keeperService.getKeeperNames(keep_list);
			if (flag) {
				if (keeperNames.length() > 7) {
					keeperNames = keeperNames.substring(0, 7) + "...";
				}
			}
		}

		return keeperNames;
	}

	@Override
	@Transactional(rollbackFor = Exception.class)
	public Map<String, Object> updateOrSave(HttpServletRequest request, String tankJson, Integer orgId)
			throws Exception {
		Map<String, Object> modelMap = new HashMap<String, Object>();

        // JSON字符串转对象
        ObjectMapper mapper = new ObjectMapper();
        BasicTank basicTank = mapper.readValue(tankJson, BasicTank.class);

        // 校验编码是否重复
        BasicTankExample example = new BasicTankExample();
        BasicTankExample.Criteria criteria = example.createCriteria();
        criteria.andOrgIdEqualTo(orgId);
        criteria.andStoragetankCodeEqualTo(basicTank.getStoragetankCode());
        List<BasicTank> list = null;
        if (null != basicTank.getId() && !"".equals(basicTank.getId())) {//修改
        	criteria.andIdNotEqualTo(basicTank.getId());
        	
        	// 查询除当前数据外还要别的油罐编码跟当前录入的编码一样，一样就是有重复的，没有就可以录入
        	list = basicTankMapper.selectByExample(example);
        	if (null != list && list.size() > 0) {
        		// 获取自己数据的ID
        		modelMap.put("status", "error");
        		modelMap.put("msg", "油罐编码已存在，不可与其它油罐编码重复！");
        		return modelMap;
        	}
        } else {//新增
        	list = basicTankMapper.selectByExample(example);
        	if (null != list && list.size() > 0) {
        		modelMap.put("status", "error");
        		modelMap.put("msg", "油罐编码已存在，不可与其它油罐编码重复！");
        		return modelMap;
        	}
        }

        //更新油罐信息
        this.saveOrEdit(request, basicTank, orgId);

        //更新单位表中仓房数、油罐数、有效仓容、有效罐容
        basicStorehouseService.editOrgChNum(orgId);

        modelMap.put("status", "success");
        modelMap.put("msg", "保存成功！");

        return modelMap;
	}

	@Override
	public void updateTankCrkStatus(BasicTank basicTank) throws Exception {

        basicTankMapper.updateByPrimaryKeySelective(basicTank);
	}

	@Override
	@Transactional(rollbackFor = Exception.class)
	public Map<String, String> saveOrUpdateSptTankData(String datas) throws Exception {
		Map<String, String> resultMap = new HashMap<>();
		BasicTank tank = null;

		JSONObject obj = null;
		if (StringUtils.isNotBlank(datas)) {
        	obj = JSONObject.parseObject(datas);
        } else {
        	resultMap.put("status", "error");
        	resultMap.put("msg", "所传的数据串是空的!");
        	return resultMap;
        }
        
        Map<String, Object> check = dataCheck(obj);
        String msg = check.get("msg").toString();
        if (msg.length() == 0) {
        	tank = (BasicTank)check.get("tank");
        	
        	boolean is_save = true;//是否是新增，true是，false否
        	if (StringUtils.isNotBlank(tank.getId())) {
        		is_save = false;
        	}
        	
        	//组装并且持久化仓房表的数据
        	BasicStorehouse storehouse = getBasicStorehouse(tank);

        	//持久化油罐数据
        	tank.setId(storehouse.getStorehouseId().toString());
        	updateTankDatas(is_save, tank);

        	//组装并且持久化油罐货位表的数据
        	getBasicTankhw(tank, is_save);

			resultMap.put("status", "success");
        	resultMap.put("msg", "操作成功");
		} else {
			resultMap.put("status", "error");
        	resultMap.put("msg", msg);
		}
        
		return resultMap;
	}

	/**
	 * 校验市平台传过来的油罐数据
	 * @param obj
	 * @return
	 * @throws Exception
	 */
	public Map<String, Object> dataCheck(JSONObject obj) throws Exception {
		
		Map<String, Object> map = new HashMap<>();
		
		BasicTank tank = new BasicTank();
		
		StringBuffer sbf = new StringBuffer(100);
		
		boolean is_save = true;//是否是新增，true是，false否

		//市平台数据主键ID
		String sptid = obj.getString("id");
		if (StringUtils.isBlank(sptid)) {
			sbf.append("id不能为空;");
		} else {
			//查询当前数据是否已经存在
			BasicTankExample example = new BasicTankExample();
			BasicTankExample.Criteria criteria = example.createCriteria();
			criteria.andSptDataidEqualTo(sptid);
			List<BasicTank> list = basicTankMapper.selectByExample(example);
			if (null != list && list.size() > 0) {//如果有了，那就不是新增，这是修改
				is_save = false;
				tank = list.get(0);
			} else {//这是新增
				//库区标准编码
		    	String kqdm = obj.getString("kqdm");
		    	if (StringUtils.isNotBlank(kqdm)) {
		    		OrgInfo orgInfo = OrgInfoMapper.selectByPrimaryKey(kqdm.trim());
		        	if (null != orgInfo && !"".equals(orgInfo)) {
		        		tank.setOrgCode(orgInfo.getOrgCode());
		        		tank.setOrgId(orgInfo.getOrgId());
		        		tank.setKqdm(kqdm.trim());
		        	} else {
		        		sbf.append("kqdm有误;");
		        	}
				}

		    	//创建时间
				tank.setCreatedate(new Date());
				//市平台数据ID
				tank.setSptDataid(sptid);
			}
		}

		//油罐编码
		String tankcode = obj.getString("realYgbh");
		if (StringUtils.isBlank(tankcode)) {
			sbf.append("realYgbh不能为空;");
		}
		Pattern p = Pattern.compile("YG[0-9]{3}");
    	Matcher m = p.matcher(tankcode);
    	boolean flag = m.matches();
    	if (!flag) {
			sbf.append("油罐编码数据只能是YG加三位数字，如：YG001;");
		} else {
			//先判断是否编码重复,要在市平台油罐基础数据主键ID不为空的情况下判断
			if (StringUtils.isNotBlank(tank.getSptDataid()) && tank.getOrgId() != null) {
				BasicTankExample example = new BasicTankExample();
				BasicTankExample.Criteria criteria = example.createCriteria();
				criteria.andOrgIdEqualTo(tank.getOrgId());
				criteria.andStoragetankCodeEqualTo(tankcode);
				if (!is_save) {//如果是修改，那么判断时要排除掉要修改的这条数据
					criteria.andSptDataidNotEqualTo(tank.getSptDataid());
				}
				List<BasicTank> list = basicTankMapper.selectByExample(example);
				if (null != list && list.size() > 0) {
				    sbf.append("realYgbh油罐编码重复了;");
				}
				
			}
			tank.setStoragetankCode(tankcode);
		}
 
    	//油罐名称
    	String tankName = obj.getString("ygmc");
    	if (StringUtils.isBlank(tankName)) {
			sbf.append("ygmc不能为空;");
		} else {
			tank.setStoragetankName(tankName);
		}
    	
    	//罐容
    	String tankCapacity = obj.getString("sjgr");
    	if (StringUtils.isBlank(tankCapacity)) {
			sbf.append("sjgr不能为空;");
		} else {
			BigDecimal gr = new BigDecimal(tankCapacity).setScale(3, BigDecimal.ROUND_DOWN);
			tank.setTankCapacity(gr);
		}
    	
    	//油罐及附属设施是否完好（1：是 0：否 9:其他或不确定）
    	String ygjfssssfwh = obj.getString("ygjfssssfwh");
    	if (StringUtils.isNotBlank(ygjfssssfwh)) {
    		BasicEnum emm = basicEnumService.getBasicEnum(1035, ygjfssssfwh);
    		if (null != emm) {
    			tank.setFacilitiesType(emm.getEnumid());
    		} else {
    			sbf.append("ygjfssssfwh参数有误,请联系管理员;");
    		}
    	} else {
    		sbf.append("sygjfssssfwh不能为空;");
    	}

    	//油罐类型（1：立式油罐 2：卧式油罐 3：油槽(池) 4：地下油罐 5：其他）
    	String yglx = obj.getString("yglx");
    	if (StringUtils.isNotBlank(yglx)) {
    		BasicEnum emm = basicEnumService.getBasicEnum(7020, yglx);
    		if (null != emm) {
    			tank.setTankType(emm.getEnumid());
    		} else {
    			sbf.append("yglx参数有误,请联系管理员;");
    		}
    	} else {
    		sbf.append("yglx不能为空;");
		}

    	//有无加热装置（1：有 0：无 9:其他或不确定）
    	String ywjrzz = obj.getString("ywjrzz");
    	if (StringUtils.isNotBlank(ywjrzz)) {
    		BasicEnum emm = basicEnumService.getBasicEnum(1035, ywjrzz);
    		if (null != emm) {
    			tank.setHeatingType(emm.getEnumid());
    		} else {
    			sbf.append("ywjrzz参数有误,请联系管理员;");
    		}
    	} else {
    		sbf.append("ywjrzz不能为空;");
		}

    	//油罐内直径
    	String diameter = obj.getString("ygnzj");
    	if (StringUtils.isBlank(diameter)) {
			sbf.append("ygnzj不能为空;");
		} else {
			BigDecimal zj = new BigDecimal(diameter).setScale(2, BigDecimal.ROUND_DOWN);
			tank.setDiameter(zj);
		}

    	//油罐高度
    	String yggd = obj.getString("yggd");
    	if (StringUtils.isBlank(yggd)) {
			sbf.append("yggd不能为空;");
		} else {
			BigDecimal height = new BigDecimal(yggd).setScale(2, BigDecimal.ROUND_DOWN);
			tank.setHeight(height);
		}

    	//检定方式（1：标定 0：非标定 9:其他或不确定）
    	String jdfs = obj.getString("jdfs");
    	if (StringUtils.isNotBlank(jdfs)) {
    		BasicEnum emm = basicEnumService.getBasicEnum(6997, jdfs);
    		if (null != emm) {
    			tank.setCheckWay(emm.getEnumid());
    		} else {
    			sbf.append("jdfs参数有误,请联系管理员;");
    		}
    	} else {
    		sbf.append("jdfs不能为空;");
		}

    	//焊接方式（1：对接 2：搭接 9:其他或不确定）
    	String hjfs = obj.getString("hjfs");
    	if (StringUtils.isNotBlank(hjfs)) {
    		BasicEnum emm = basicEnumService.getBasicEnum(7001, hjfs);
    		if (null != emm) {
    			tank.setWeldWay(emm.getEnumid());
    		} else {
    			sbf.append("hjfs参数有误,请联系管理员;");
    		}
    	} else {
    		sbf.append("hjfs不能为空;");
		}
    	
    	//油罐状态（1：完好 2：需小修 3：需大修 4：待报废 5：待拆除 6：长期闲置 9：其他）
    	String ygzt = obj.getString("ygzt");
    	if (StringUtils.isNotBlank(ygzt)) {
    		BasicEnum emm = basicEnumService.getBasicEnum(7012, ygzt);
    		if (null != emm) {
    			tank.setTankStatus(emm.getEnumid());
    		} else {
    			sbf.append("ygzt参数有误,请联系管理员;");
    		}
    	} else {
    		sbf.append("ygzt不能为空;");
		}
    	
    	//油罐底面积
    	String ygdmj = obj.getString("ygdmj");
    	if (StringUtils.isBlank(ygdmj)) {
			sbf.append("ygdmj不能为空;");
		} else {
			BigDecimal bottomArea = new BigDecimal(ygdmj).setScale(2, BigDecimal.ROUND_DOWN);
			tank.setBottomArea(bottomArea);
		}
    	
    	//装油高度(设计储油高度、罐内高度)
    	String zygd = obj.getString("zygd");
    	if (StringUtils.isBlank(zygd)) {
			sbf.append("zygd不能为空;");
		} else {
			BigDecimal designHeight = new BigDecimal(zygd).setScale(2, BigDecimal.ROUND_DOWN);
			tank.setDesignHeight(designHeight);
		}

    	//油罐出油口高度
    	String ygcykgd = obj.getString("ygcykgd");
    	if (StringUtils.isNotBlank(ygcykgd)) {
    		BigDecimal oilHeight = new BigDecimal(ygcykgd).setScale(2, BigDecimal.ROUND_DOWN);
			tank.setOilHeight(oilHeight);
		}

    	//油罐检查口高度
    	String ygjckgd = obj.getString("ygjckgd");
    	if (StringUtils.isNotBlank(ygjckgd)) {
    		BigDecimal insportHeight = new BigDecimal(ygjckgd).setScale(2, BigDecimal.ROUND_DOWN);
			tank.setInsportHeight(insportHeight);
		}

    	//建造日期
    	String sjnd = obj.getString("sjnd");
    	if (StringUtils.isBlank(sjnd)) {
    		sbf.append("sjnd不能为空;");
    	} else {
    		tank.setBuilddate(ParameterUtil.string2date(sjnd));
    	}

    	//监理单位
    	String jldw = obj.getString("jldw");
    	if (StringUtils.isNotBlank(jldw)) {
			tank.setJldw(jldw.trim());
		}

    	//建设单位
    	String jsdw = obj.getString("jsdw");
    	if (StringUtils.isNotBlank(jsdw)) {
			tank.setJsdw(jsdw.trim());
		}

    	//设计单位
    	String sjdw = obj.getString("sjdw");
    	if (StringUtils.isNotBlank(sjdw)) {
			tank.setSjdw(sjdw.trim());
		}

    	//出入库状态(1：空仓 2：入库中 3：封仓4：出库中)
//    	String crkStatus = obj.getString("crkStatus");
//    	if (StringUtils.isNotBlank(crkStatus)) {
//    		tank.setCrkStatus(crkStatus.trim());
//    	} else {
//    		if (is_save) {//新增给1，空仓
//    			tank.setCrkStatus("1");
//    		}
//    	}

    	//储存粮油类型(0：原油 1：成品油)
//    	String lylx = obj.getString("lylx");
//    	if (StringUtils.isNotBlank(lylx)) {
//    		tank.setLylx(lylx.trim());
//    	} else {
//    		//出入库状态要是不等于空，并且不是空仓，那么就要给粮油类型赋值
//    		if (StringUtils.isNotBlank(crkStatus) && !"1".equals(tank.getCrkStatus())) {
//    			sbf.append("crkStatus不为空并且不等于1时，lylx不能为空;");
//    		}
//    	}

    	//油罐库区图
    	String ygkqt = obj.getString("ygkqt");
    	if (StringUtils.isNotBlank(ygkqt)) {
			tank.setTanklibChart(ygkqt.trim());
		}

    	//油罐图
    	String ygpmt = obj.getString("ygpmt");
    	if (StringUtils.isNotBlank(ygpmt)) {
			tank.setTankChart(ygpmt.trim());
		}
    	
    	//油罐使用状态（0：弃用 1：在用）
    	String ygsyzt = ObjectUtils.toString(obj.getString("ygsyzt"),"1");
		tank.setDelFlag(Integer.parseInt(ygsyzt.trim()));

    	//油罐标准编码
    	String ygdm = obj.getString("ygdm");
    	if (StringUtils.isNotBlank(ygdm)) {
			tank.setYgdm(ygdm.trim());
		}

    	//油罐廒间标准编码
    	String ajdh = obj.getString("ajdh");
    	if (StringUtils.isNotBlank(ajdh)) {
			tank.setYgajdm(ajdh.trim());
		}
    	
		String msg = sbf.toString();
		map.put("msg", msg);
		
		map.put("tank", tank);
		return map;
	}

	/**
	 * 组装仓房表的数据
	 * @param tank
	 * @return
	 */
	private BasicStorehouse getBasicStorehouse(BasicTank basicTank) throws Exception {
		BasicStorehouse storehouse = null;
		if(basicTank.getId() == null || "".equals(basicTank.getId())){//新增
			storehouse = new BasicStorehouse();
        	storehouse.setStorehouseCode(basicTank.getStoragetankCode());
        	storehouse.setStorehouseName(basicTank.getStoragetankName());
        	storehouse.setOrgId(basicTank.getOrgId());
        	storehouse.setDatatype("1");
        	storehouse.setDelFlag(1);
        	storehouse.setCreatedate(new Date());
        	storehouse.setLibraryType("0");
        	storehouse.setCfbm(basicTank.getYgdm());
        	storehouse.setAjbm(basicTank.getYgajdm());

        	//插入
        	basicStorehouseMapper.insertSelective(storehouse);

		} else {//修改
			storehouse = new BasicStorehouse();
			storehouse.setStorehouseId(Integer.parseInt(basicTank.getId()));
			storehouse.setStorehouseName(basicTank.getStoragetankName());
			storehouse.setStorehouseCode(basicTank.getStoragetankCode());
			storehouse.setDelFlag(basicTank.getDelFlag());
			storehouse.setCfbm(basicTank.getYgdm());
        	storehouse.setAjbm(basicTank.getYgajdm());

        	//修改
        	basicStorehouseMapper.updateByPrimaryKeySelective(storehouse);
		}
		return storehouse;
	}

	/**
	 * 插入或更新油罐表数据
	 * @param is_save 是否是新增
	 * @param tank 油罐数据对象
	 * @throws Exception
	 */
	private void updateTankDatas(boolean is_save, BasicTank tank) throws Exception {
		if (is_save) {
			tank.setCrkStatus("1");
			basicTankMapper.insertSelective(tank);
		} else {
			basicTankMapper.updateByPrimaryKey(tank);
		}
	}
	
	/**
	 * 组装油罐货位表的数据
	 * @param tank
	 * @return
	 */
	private BasicTankHw getBasicTankhw(BasicTank basicTank, boolean is_save) throws Exception {
		BasicTankHw tankhw = new BasicTankHw();
		tankhw.setOrgId(basicTank.getOrgId());
		tankhw.setHwmc(basicTank.getStoragetankName());
		tankhw.setHwqyrq(basicTank.getBuilddate());
		tankhw.setHwrl(basicTank.getTankCapacity());
//		tankhw.setBgdw(bgdw);
		tankhw.setCzbz("i");
		tankhw.setZhgxsj(basicTank.getCreatedate());
		tankhw.setCrkStatus(basicTank.getCrkStatus());
		tankhw.setId(Integer.parseInt(basicTank.getId()));
		
		if(is_save){
    		tankhw.setHwbm(basicTank.getYghwdm());
			basicTankHwMapper.insertSelective(tankhw);
		} else {
			tankhw.setHwbm(basicTank.getYghwdm());
			tankhw.setCzbz("u");
			basicTankHwMapper.updateByPrimaryKeySelective(tankhw);
		}
		return tankhw;
	}

}
