package com.chinaitop.depot.basic.service.impl;

import java.io.ByteArrayInputStream;
import java.io.InputStream;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.Iterator;
import java.util.List;
import java.util.Map;

import javax.annotation.Resource;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import org.springframework.stereotype.Service;

import com.alibaba.fastjson.JSONArray;
import com.alibaba.fastjson.JSONObject;
import com.chinaitop.depot.basic.mapper.BasicStorehouseMapper;
import com.chinaitop.depot.basic.mapper.BasicWarehouseMapper;
import com.chinaitop.depot.basic.model.BasicStorehouse;
import com.chinaitop.depot.basic.model.BasicStorehouseExample;
import com.chinaitop.depot.basic.model.BasicWarehouse;
import com.chinaitop.depot.basic.model.BasicWarehouseExample;
import com.chinaitop.depot.basic.service.UserAndCfHwExportService;
import com.chinaitop.utils.CommonTool;

@Service
public class UserAndCfHwExportServiceImpl implements UserAndCfHwExportService {

	@Resource
	private BasicStorehouseMapper houseMapper;

	@Resource
	private BasicWarehouseMapper wareHouseMapper;

	@Override
	public void exportUserAndCfhw(HttpServletRequest request, HttpServletResponse response, String userList) {
		Map<String, Object> map = new HashMap<String, Object>();
		List<Map<String, Object>> user_list = new ArrayList<Map<String, Object>>(); //用户信息
		List<Map<String, Object>> cfhw_list = new ArrayList<Map<String, Object>>(); //仓房货位信息
		try {
			// 获取当前单位的用户数据的用户名和密码
			JSONArray json = JSONArray.parseArray(userList);
			if (null != json && json.size() > 0) {
				Map<String, Object> user_map = null;
				for (@SuppressWarnings("rawtypes")
				Iterator iterator = json.iterator(); iterator.hasNext();) {
					JSONObject obj = (JSONObject) iterator.next();
					user_map = new HashMap<String, Object>();
					user_map.put("UNAME", obj.get("realName").toString().replace(" ", ""));
					user_map.put("USERNAME", obj.get("username").toString().replace(" ", ""));
					user_map.put("PWD", CommonTool.getMd5(obj.get("password").toString()));
					user_list.add(user_map);
				}
			}
			map.put("user", user_list);

			//获取单位的仓房
			BasicStorehouseExample houseExample = new BasicStorehouseExample();
			BasicStorehouseExample.Criteria houseCriteria = houseExample.createCriteria();
			houseCriteria.andDelFlagEqualTo(1); //查询没删除的数据
			List<BasicStorehouse> houseList = houseMapper.selectByExample(houseExample);
			
			//获取单位的货位
			BasicWarehouseExample warehouseExample = new BasicWarehouseExample();
			BasicWarehouseExample.Criteria warehouseCriteria = warehouseExample.createCriteria();
			warehouseCriteria.andDelFlagEqualTo(1); //查询没删除的数据
			List<BasicWarehouse> warehouseList = wareHouseMapper.selectByExample(warehouseExample);

			// 拼接仓房和货位
			if (null != houseList && houseList.size() > 0) {
				Map<String, Object> cfhw_map = null;
				String cf_id = null; //仓房ID
				String hwCf_id = null; //货位坐在仓房的ID
				for (BasicStorehouse house : houseList) {
					cf_id = house.getStorehouseId() + "";
					int count = 0;
					for (BasicWarehouse ware : warehouseList) {
						hwCf_id = ware.getStorehouseId() + "";
						if (cf_id.equals(hwCf_id)) {
							cfhw_map = new HashMap<String, Object>();
							count = 1;
							cfhw_map.put("cf_id", cf_id);
							cfhw_map.put("cf_code", house.getStorehouseCode().toString().replace(" ", ""));
							cfhw_map.put("cf_name", house.getStorehouseName().toString().replace(" ", ""));
							cfhw_map.put("hw_id", ware.getWarehouseId());
							cfhw_map.put("hw_code", ware.getWarehouseCode().toString().replace(" ", ""));
							cfhw_map.put("hw_name", ware.getWarehouseName().toString().replace(" ", ""));
							cfhw_list.add(cfhw_map);
						}
					}
					if (count != 1) {
						cfhw_map = new HashMap<String, Object>();
						cfhw_map.put("cf_id", cf_id);
						cfhw_map.put("cf_code", house.getStorehouseCode().toString().replace(" ", ""));
						cfhw_map.put("cf_name", house.getStorehouseName().toString().replace(" ", ""));
						cfhw_map.put("hw_id", null);
						cfhw_map.put("hw_code", null);
						cfhw_map.put("hw_name", null);
						cfhw_list.add(cfhw_map);
					} else {
						count = 0;
					}
				}
			}

			map.put("cfhw", cfhw_list);

			// 设置文件输出信息
			response.setContentType("charset=utf-8");
			response.setContentType("bin");
			response.setContentType("application/x-download");

			String outputFileName = "scy_init.txt"; //输出文件的文件名

//			//设置火狐编码
			String agent = request.getHeader("User-Agent");
			if (null != agent && "" != agent) {
			    agent = agent.toLowerCase();
			    if (agent.indexOf("firefox") != -1) {
			    	outputFileName = new String(outputFileName.getBytes("UTF-8"),"ISO-8859-1");  
			    } else {
			    	outputFileName = java.net.URLEncoder.encode(outputFileName,"UTF-8");  
			    }
			}

			InputStream is=new ByteArrayInputStream(map.toString().getBytes("utf-8"));

			response.setHeader("Content-Disposition", "attachment; filename=" + outputFileName);

			byte[] bs = new byte[1024];
			int len;
			while ((len = is.read(bs)) != -1) {
			    response.getOutputStream().write(bs, 0, len);
			}
			response.getOutputStream().close();
			is.close();
		} catch (Exception e) {
			e.printStackTrace();
		}
	}

}
