package com.chinaitop.depot.common.controller;

import java.io.File;
import java.io.FileInputStream;
import java.io.IOException;
import java.io.InputStream;

import javax.servlet.http.HttpServletRequest;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.beans.factory.annotation.Value;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;
import org.springframework.web.multipart.MultipartFile;

import com.chinaitop.depot.basic.model.BusinessFile;
import com.chinaitop.depot.basic.service.BusinessFileService;
import com.chinaitop.depot.utils.ImageHelper;


@RestController
@RequestMapping(value="/fileUpload")
public class FileUploadController {

	@Autowired
    private BusinessFileService businessFileService;
	
    @Value("${web.upload-path}")
    private String uploadPath;
    
    @RequestMapping(value="/uploadFile")
	public String uploadFile(MultipartFile file, String fileType, HttpServletRequest request) throws IllegalStateException, IOException {

		// 文件相对路径
		String relativePath = "/upload/" + fileType;
		// 如路径不存在，则创建它
		File directory = new File(uploadPath + relativePath);
		if (!directory.exists()) {
			directory.mkdirs();
		}
		String filePath = relativePath + "/" + System.currentTimeMillis()+"_"+file.getOriginalFilename();
		// 复制 文件
		file.transferTo(new File(uploadPath + filePath));
		return filePath;
	}

	@RequestMapping(value="/uploadFileYS")
	public String uploadFileYS(MultipartFile file, String fileType, HttpServletRequest request) throws IllegalStateException, IOException {

		// 文件相对路径image
		String relativePath = "/upload/" + fileType;
		// 如路径不存在，则创建它
		File directory = new File(uploadPath + relativePath);
		if (!directory.exists()) {
			directory.mkdirs();
		}
		//保存在服务器的图片路径和文件全路径
		String filePath = relativePath + "/" + System.currentTimeMillis()+"_"+file.getOriginalFilename();

		// 复制 文件
		file.transferTo(new File(uploadPath + filePath));
		//上传后压缩
		String img_path = uploadPath + filePath;

		File saveFile = new File(img_path);
		// 原图片的路径
		InputStream in = new FileInputStream(new File(img_path));

		if (ImageHelper.compress(in, saveFile, 200)) {
			System.out.println("图片压缩完成！");
		}
		return filePath;
	}

	@RequestMapping(value="/updateFileBusiness")
	public BusinessFile uploadFile(MultipartFile file, String type, Integer bid, Integer userId,Integer orgId,HttpServletRequest request){

		BusinessFile businessFile = businessFileService.uploadFile(file,type,bid, userId, orgId);
        return businessFile;
    }

	
}
