package com.chinaitop.depot.feign;

import com.alibaba.fastjson.JSONObject;
import com.chinaitop.depot.basic.model.BasicStorehouse;
import com.chinaitop.depot.basic.model.BasicWarehouse;
import com.chinaitop.depot.basic.service.BasicStorehouseService;
import com.chinaitop.depot.basic.service.BasicWarehouseService;
import com.chinaitop.utils.ParameterUtil;
import org.springframework.web.bind.annotation.*;
import javax.annotation.Resource;

/**
 * @author qingsong.han
 * @description: feignService
 * @create 2018-07-31 12:17
 */
@RestController
public class CommonFeign {

    //仓房service
	@Resource
	private BasicStorehouseService basicStorehouseService;
	//货位service
    @Resource
    private BasicWarehouseService basicWarehouseService;

    /**
     * 数量管理出入库,获取仓房名称货位名称
     * @param sjcf
     * @param sjhw
     * @return
     */
    @RequestMapping(value = "/getStorehouseWarehouseName", method = RequestMethod.POST)
    public JSONObject getStorehouseWarehouseName(Integer sjcf, Integer sjhw) {
        JSONObject json = new JSONObject();
        //获取仓房名称
        BasicStorehouse basicStorehouse = null;
        try {
            if (sjcf != null) {
                basicStorehouse = basicStorehouseService.findByPrimary(sjcf);//实际仓房ID
            } else {
                basicStorehouse = new BasicStorehouse();
            }

        } catch (Exception e) {
            e.printStackTrace();
            basicStorehouse = new BasicStorehouse();
        }

        basicStorehouse =  ParameterUtil.isnull(basicStorehouse)?new BasicStorehouse():basicStorehouse;
        json.put("cfmc",ParameterUtil.isnull(basicStorehouse.getStorehouseName())?"":basicStorehouse.getStorehouseName());//仓房名称

        //获取货位名称
        BasicWarehouse basicWarehouse = null;
        if (ParameterUtil.isnotnull(sjhw))
            basicWarehouse = basicWarehouseService.findByParmaryKey(sjhw);//实际货位ID
        else
            basicWarehouse = new BasicWarehouse();

        basicWarehouse = ParameterUtil.isnull(basicWarehouse)?new BasicWarehouse():basicWarehouse;
        json.put("hwmc",ParameterUtil.isnull(basicWarehouse.getWarehouseName())?"":basicWarehouse.getWarehouseName());//货位名称
        return json;
    }


}
