package com.chinaitop.depot.job.service;

import java.util.List;
import java.util.Map;

import com.chinaitop.depot.job.model.ScheduleJob;

/**
 * 定时任务
 * 
 * @author chenshun
 * @email sunlightcs@gmail.com
 * @date 2016年11月28日 上午9:55:32
 */
public interface ScheduleJobService {

	/**
	 * 根据ID，查询定时任务
	 */
	ScheduleJob find(Long jobId);
	
	/**
	 * 查询总数
	 */
	/*int queryTotal(Map<String, Object> map);*/
	/**
	 * 批量更新定时任务状态
	 */
	int updateBatch(Long[] jobIds, int status);
	
	/**
	 * 立即执行
	 */
	void run(Long id);
	
	/**
	 * 暂停运行
	 */
	void pause(Long id);
	
	/**
	 * 恢复运行
	 */
	void resume(Long id);

    /**
     * @param pageNum
     * @param pageSize
     * @return
     */
    List<ScheduleJob> queryByExample(Integer pageNum, Integer pageSize, Integer orgId);

    /**
     * @param scheduleJob
     * @param userId
     */
    Map<String, String> update(ScheduleJob scheduleJob, Integer userId);

    /**
     * @param scheduleJob
     * @param orgId
     * @param userId
     */
    Map<String, String> add(ScheduleJob scheduleJob, Integer orgId, Integer userId);

    /**
     * @param id
     */
    void remove(Long id);
}
