package com.chinaitop.utils;

import java.text.SimpleDateFormat;
import java.util.Date;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

import com.chinaitop.depot.basic.model.BasicTank;
import com.google.gson.Gson;

public class BasicTankDataSynchronization {

	private static String urls = "http://192.168.123.123:14100";
	private static SimpleDateFormat format = new SimpleDateFormat("yyyy-MM-dd'T'HH:mm:ss.SSSZ");

	/**
	 * 查询油罐信息
	 */
	@SuppressWarnings("all")
	public static List queryTank() {
		Gson gson = new Gson();
		Map<String,Object> params = new HashMap<String,Object>();
		//json对象转换成json字符串
		String jsonStr = gson.toJson(params);
		String result = HttpClientUtil.doPostJson(urls+"/oiltankList", jsonStr);
		System.out.print(result);
		params = gson.fromJson(result, Map.class);
		List list = (List)params.get("data");
		return list;
	}

	/**
	 * 油罐信息同步---插入
	 * 
	 * @param tank
	 */
	public static void tankSynchronizationInsert(BasicTank tank) {
		Gson gson = new Gson();
		Map<String,Object> params = new HashMap<String,Object>();
		params.put("createDate", format.format(tank.getCreatedate()));
		params.put("creator", "");
		params.put("creatorCode", "");
		params.put("kddm", tank.getOrgId());
		params.put("kdmc", "");
		params.put("refreshTime", format.format(new Date()));
		params.put("refresher", "");
		params.put("refresherCode", "");
		params.put("remark", "");
		params.put("sjgr", tank.getTankCapacity());
		params.put("sjgr01", "");
		params.put("sjnd", "");
		params.put("status", "");
		params.put("ygbh", tank.getStoragetankCode());
		params.put("ygcykgd", "");
		params.put("ygdmj", "");
		params.put("yggd", tank.getHeight());
		params.put("ygjckgd", "");
		params.put("ygjd", "");
		params.put("ygkqt", "");
		params.put("yglx", tank.getTankType());
		params.put("ygmc", tank.getStoragetankName());
		params.put("ygnzj", "");
		params.put("ygpmt", "");
		params.put("ygsyzt", tank.getTankApply());
		params.put("ygwd", "");
		params.put("ygzj", tank.getDiameter());
		params.put("ygzt", tank.getTankStatus());
		params.put("zygd", "");
		
		//json对象转换成json字符串
		String jsonStr = gson.toJson(params);
		String result = HttpClientUtil.doPostJson(urls+"/oiltank", jsonStr);
		System.out.print(result);
	}

	/**
	 * 油罐信息同步---修改
	 * 
	 * @param params
	 * @param tank
	 */
	public static void tankSynchronizationUpdate(Map<String,Object> params, BasicTank tank) {
		Gson gson = new Gson();
		params.put("createDate", format.format(tank.getCreatedate()));
		params.put("kddm", tank.getOrgId());
		params.put("refreshTime", format.format(new Date()));
		params.put("sjgr", tank.getTankCapacity());
		params.put("ygbh", tank.getStoragetankCode());
		params.put("yggd", tank.getHeight());
		params.put("yglx", tank.getTankType());
		params.put("ygmc", tank.getStoragetankName());
		params.put("ygsyzt", tank.getTankApply());
		params.put("ygzj", tank.getDiameter());
		params.put("ygzt", tank.getTankStatus());
		
		//json对象转换成json字符串
		String jsonStr = gson.toJson(params);
		String result = HttpClientUtil.doPutJson(urls+"/oiltank", jsonStr);
		System.out.print(result);
	}
}
