package com.chinaitop.utils;

import java.text.SimpleDateFormat;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

import com.chinaitop.depot.basic.model.BasicWarehouse;
import com.google.gson.Gson;

public class WarehouseDataSynchronization {
	private static String urls = "http://192.168.123.123:14100";
	private static SimpleDateFormat format = new SimpleDateFormat("yyyy-MM-dd'T'HH:mm:ss.SSSZ");

	/**
	 * 查询货位信息
	 */
	@SuppressWarnings("all")
	public static List queryWarehouse() {
		Gson gson = new Gson();
		Map<String,Object> params = new HashMap<String,Object>();
		//json对象转换成json字符串
		String jsonStr = gson.toJson(params);
		String result = HttpClientUtil.doPostJson(urls+"/goodsallocationList", jsonStr);
		System.out.print(result);
		params = gson.fromJson(result, Map.class);
		List list = (List)params.get("data");
		return list;
	}

	/**
	 * 货位信息同步---插入
	 * 
	 * @param warehouse
	 */
	public static void warehouseSynchronizationInsert(BasicWarehouse warehouse) {
		Gson gson = new Gson();
		Map<String,Object> params = new HashMap<String,Object>();
		params.put("ajbh", "");
		params.put("ajmc", "");
		params.put("createDate", format.format(warehouse.getCreatedate()));
		params.put("creator", warehouse.getCreatename());
		params.put("creatorCode", "");
		params.put("hwbh", warehouse.getWarehouseCode());
		params.put("hwcr", warehouse.getWarehouseCapacity());
		params.put("hwmc", warehouse.getWarehouseName());
		params.put("hwzt", warehouse.getWarehouseStatus());
		params.put("qyrq", format.format(warehouse.getWarehouseUseTime()));
		params.put("refreshTime", format.format(warehouse.getUpdatedate()));
		params.put("refresher", warehouse.getUpdatename());
		params.put("refresherCode", "");
		params.put("remark", warehouse.getRemark());
		params.put("status", 0);
		
		//json对象转换成json字符串
		String jsonStr = gson.toJson(params);
		String result = HttpClientUtil.doPostJson(urls+"/goodsallocation", jsonStr);
		System.out.print(result);
	}
	
	/**
	 * 库点信息同步---更新
	 */
	public static void warehouseSynchronizationUpdate(Map<String,Object> params, BasicWarehouse warehouse) {
		Gson gson = new Gson();
		params.put("creatorCode", "");
		params.put("hwbh", warehouse.getWarehouseCode());
		params.put("hwcr", warehouse.getWarehouseCapacity());
		params.put("hwmc", warehouse.getWarehouseName());
		params.put("hwzt", warehouse.getWarehouseStatus());
		params.put("qyrq", format.format(warehouse.getWarehouseUseTime()));
		params.put("refreshTime", format.format(warehouse.getUpdatedate()));
		params.put("refresher", warehouse.getUpdatename());
		params.put("remark", warehouse.getRemark());
		//json对象转换成json字符串
		String jsonStr = gson.toJson(params);
		String result = HttpClientUtil.doPutJson(urls+"/goodsallocation", jsonStr);
		System.out.print(result);
	}

}
